# Distances.jl

[![Build Status](https://github.com/JuliaStats/Distances.jl/workflows/CI/badge.svg?branch=master)](https://github.com/JuliaStats/Distances.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![Coverage Status](http://codecov.io/github/JuliaStats/Distances.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaStats/Distances.jl?branch=master)

A Julia package for evaluating distances (metrics) between vectors.

This package also provides optimized functions to compute column-wise and
pairwise distances, which are often substantially faster than a straightforward
loop implementation. (See the benchmark section below for details).

## Supported distances

* Euclidean distance
* Squared Euclidean distance
* Periodic Euclidean distance
* Cityblock distance
* Total variation distance
* Jaccard distance
* Rogers-Tanimoto distance
* Chebyshev distance
* Minkowski distance
* Hamming distance
* Cosine distance
* Correlation distance
* Chi-square distance
* Kullback-Leibler divergence
* Generalized Kullback-Leibler divergence
* Rényi divergence
* Jensen-Shannon divergence
* Mahalanobis distance
* Squared Mahalanobis distance
* Bhattacharyya distance
* Hellinger distance
* Haversine distance
* Spherical angle distance
* Mean absolute deviation
* Mean squared deviation
* Root mean squared deviation
* Normalized root mean squared deviation
* Bray-Curtis dissimilarity
* Bregman divergence

For `Euclidean distance`, `Squared Euclidean distance`, `Cityblock distance`,
`Minkowski distance`, and `Hamming distance`, a weighted version is also provided.

## Basic use

The library supports three ways of computation: *computing the distance between*
*two iterators/vectors*, *"zip"-wise computation*, and *pairwise computation*.
Each of these computation modes works with arbitrary iterable objects of known
size.

### Computing the distance between two iterators or vectors

Each distance corresponds to a *distance type*. You can always compute a certain
distance between two iterators or vectors of equal length using the following
syntax

```julia
r = evaluate(dist, x, y)
r = dist(x, y)
```

Here, `dist` is an instance of a distance type: for example, the type for Euclidean
distance is `Euclidean` (more distance types will be introduced in the next section).
You can compute the Euclidean distance between `x` and `y` as

```julia
r = evaluate(Euclidean(), x, y)
r = Euclidean()(x, y)
```

Common distances also come with convenient functions for distance evaluation. For
example, you may also compute Euclidean distance between two vectors as below

```julia
r = euclidean(x, y)
```

### Computing distances between corresponding objects ("column-wise")

Suppose you have two `m-by-n` matrix `X` and `Y`, then you can compute all
distances between corresponding columns of `X` and `Y` in one batch, using
the `colwise` function, as

```julia
r = colwise(dist, X, Y)
```

The output `r` is a vector of length `n`. In particular, `r[i]` is the distance
between `X[:,i]` and `Y[:,i]`. The batch computation typically runs considerably
faster than calling `evaluate` column-by-column.

Note that either of `X` and `Y` can be just a single vector -- then the `colwise`
function computes the distance between this vector and each column of the other
argument.

### Computing pairwise distances

Let `X` and `Y` have `m` and `n` columns, respectively, and the same number of rows.
Then the `pairwise` function with the `dims=2` argument computes distances between
each pair of columns in `X` and `Y`:

```julia
R = pairwise(dist, X, Y, dims=2)
```

In the output, `R` is a matrix of size `(m, n)`, such that `R[i,j]` is the
distance between `X[:,i]` and `Y[:,j]`. Computing distances for all pairs using
`pairwise` function is often remarkably faster than evaluting for each pair
individually.

If you just want to just compute distances between all columns of a matrix `X`,
you can write

```julia
R = pairwise(dist, X, dims=2)
```

This statement will result in an `m-by-m` matrix, where `R[i,j]` is the distance
between `X[:,i]` and `X[:,j]`. `pairwise(dist, X)` is typically more efficient
than `pairwise(dist, X, X)`, as the former will take advantage of the symmetry
when `dist` is a semi-metric (including metric).

To compute pairwise distances for matrices with observations stored in rows use
the argument `dims=1`.

### Computing column-wise and pairwise distances inplace

If the vector/matrix to store the results are pre-allocated, you may use the
storage (without creating a new array) using the following syntax
(`i` being either `1` or `2`):

```julia
colwise!(dist, r, X, Y)
pairwise!(dist, R, X, Y, dims=i)
pairwise!(dist, R, X, dims=i)
```

Please pay attention to the difference, the functions for inplace computation are
`colwise!` and `pairwise!` (instead of `colwise` and `pairwise`).

#### Deprecated alternative syntax

The syntax

```julia
colwise!(r, dist, X, Y)
pairwise!(R, dist, X, Y, dims=i)
pairwise!(R, dist, X, dims=i)
```

with the first two arguments (metric and results) interchanged is supported as well.
However, its use is discouraged since
[it is deprecated](https://github.com/JuliaStats/Distances.jl/pull/239) and will be
removed in a future release.

## Distance type hierarchy

The distances are organized into a type hierarchy.

At the top of this hierarchy is an abstract class **PreMetric**, which is defined to be a function `d` that satisfies

    d(x, x) == 0  for all x
    d(x, y) >= 0  for all x, y

**SemiMetric** is a abstract type that refines **PreMetric**. Formally, a *semi-metric* is a *pre-metric* that is also symmetric, as

    d(x, y) == d(y, x)  for all x, y

**Metric** is a abstract type that further refines **SemiMetric**. Formally, a *metric* is a *semi-metric* that also satisfies triangle inequality, as

    d(x, z) <= d(x, y) + d(y, z)  for all x, y, z

This type system has practical significance. For example, when computing pairwise distances
between a set of vectors, you may only perform computation for half of the pairs, derive the
values immediately for the remaining half by leveraging the symmetry of *semi-metrics*. Note
that the types of `SemiMetric` and `Metric` do not completely follow the definition in
mathematics as they do not require the "distance" to be able to distinguish between points:
for these types `x != y` does not imply that `d(x, y) != 0` in general compared to the
mathematical definition of semi-metric and metric, as this property does not change
computations in practice.

Each distance corresponds to a distance type. The type name and the corresponding mathematical
definitions of the distances are listed in the following table.

| type name            |  convenient syntax                | math definition     |
| -------------------- | --------------------------------- | --------------------|
|  Euclidean           |  `euclidean(x, y)`                | `sqrt(sum((x - y) .^ 2))` |
|  SqEuclidean         |  `sqeuclidean(x, y)`              | `sum((x - y).^2)` |
|  PeriodicEuclidean   |  `peuclidean(x, y, w)`            | `sqrt(sum(min(mod(abs(x - y), w), w - mod(abs(x - y), w)).^2))`  |
|  Cityblock           |  `cityblock(x, y)`                | `sum(abs(x - y))` |
|  TotalVariation      |  `totalvariation(x, y)`           | `sum(abs(x - y)) / 2` |
|  Chebyshev           |  `chebyshev(x, y)`                | `max(abs(x - y))` |
|  Minkowski           |  `minkowski(x, y, p)`             | `sum(abs(x - y).^p) ^ (1/p)` |
|  Hamming             |  `hamming(k, l)`                  | `sum(k .!= l)` |
|  RogersTanimoto      |  `rogerstanimoto(a, b)`           | `2(sum(a&!b) + sum(!a&b)) / (2(sum(a&!b) + sum(!a&b)) + sum(a&b) + sum(!a&!b))` |
|  Jaccard             |  `jaccard(x, y)`                  | `1 - sum(min(x, y)) / sum(max(x, y))` |
|  BrayCurtis          |  `braycurtis(x, y)`               | `sum(abs(x - y)) / sum(abs(x + y))`  |
|  CosineDist          |  `cosine_dist(x, y)`              | `1 - dot(x, y) / (norm(x) * norm(y))` |
|  CorrDist            |  `corr_dist(x, y)`                | `cosine_dist(x - mean(x), y - mean(y))` |
|  ChiSqDist           |  `chisq_dist(x, y)`               | `sum((x - y).^2 / (x + y))` |
|  KLDivergence        |  `kl_divergence(p, q)`            | `sum(p .* log(p ./ q))` |
|  GenKLDivergence     |  `gkl_divergence(x, y)`           | `sum(p .* log(p ./ q) - p + q)` |
|  RenyiDivergence     |  `renyi_divergence(p, q, k)`      | `log(sum( p .* (p ./ q) .^ (k - 1))) / (k - 1)` |
|  JSDivergence        |  `js_divergence(p, q)`            | `KL(p, m) / 2 + KL(q, m) / 2 with m = (p + q) / 2` |
|  SpanNormDist        |  `spannorm_dist(x, y)`            | `max(x - y) - min(x - y)` |
|  BhattacharyyaDist   |  `bhattacharyya(x, y)`            | `-log(sum(sqrt(x .* y) / sqrt(sum(x) * sum(y)))` |
|  HellingerDist       |  `hellinger(x, y)`                | `sqrt(1 - sum(sqrt(x .* y) / sqrt(sum(x) * sum(y))))` |
|  Haversine           |  `haversine(x, y, r = 6_371_000)` | [Haversine formula](https://en.wikipedia.org/wiki/Haversine_formula) |
|  SphericalAngle      |  `spherical_angle(x, y)`          | [Haversine formula](https://en.wikipedia.org/wiki/Haversine_formula) |
|  Mahalanobis         |  `mahalanobis(x, y, Q)`           | `sqrt((x - y)' * Q * (x - y))` |
|  SqMahalanobis       |  `sqmahalanobis(x, y, Q)`         | `(x - y)' * Q * (x - y)` |
|  MeanAbsDeviation    |  `meanad(x, y)`                   | `mean(abs.(x - y))` |
|  MeanSqDeviation     |  `msd(x, y)`                      | `mean(abs2.(x - y))` |
|  RMSDeviation        |  `rmsd(x, y)`                     | `sqrt(msd(x, y))` |
|  NormRMSDeviation    |  `nrmsd(x, y)`                    | `rmsd(x, y) / (maximum(x) - minimum(x))` |
|  WeightedEuclidean   |  `weuclidean(x, y, w)`            | `sqrt(sum((x - y).^2 .* w))`  |
|  WeightedSqEuclidean |  `wsqeuclidean(x, y, w)`          | `sum((x - y).^2 .* w)`  |
|  WeightedCityblock   |  `wcityblock(x, y, w)`            | `sum(abs(x - y) .* w)`  |
|  WeightedMinkowski   |  `wminkowski(x, y, w, p)`         | `sum(abs(x - y).^p .* w) ^ (1/p)` |
|  WeightedHamming     |  `whamming(x, y, w)`              | `sum((x .!= y) .* w)`  |
|  Bregman             |  `bregman(F, ∇, x, y; inner=dot)` | `F(x) - F(y) - inner(∇(y), x - y)` |

**Note:** The formulas above are using *Julia*'s functions. These formulas are
mainly for conveying the math concepts in a concise way. The actual implementation
may use a faster way. The arguments `x` and `y` are iterable objects, typically
arrays of real numbers; `w` is an iterator/array of parameters (like weights or
periods); `k` and `l` are iterators/arrays of distinct elements of
any kind; `a` and `b` are iterators/arrays of Bools; and finally, `p` and `q` are
iterators/arrays forming a discrete probability distribution and are therefore
both expected to sum to one.

### Precision for Euclidean and SqEuclidean

For efficiency (see the benchmarks below), `Euclidean` and
`SqEuclidean` make use of BLAS3 matrix-matrix multiplication to
calculate distances.  This corresponds to the following expansion:

```julia
(x-y)^2 == x^2 - 2xy + y^2
```

However, equality is not precise in the presence of roundoff error,
and particularly when `x` and `y` are nearby points this may not be
accurate.  Consequently, `Euclidean` and `SqEuclidean` allow you to
supply a relative tolerance to force recalculation:

```julia
julia> x = reshape([0.1, 0.3, -0.1], 3, 1);

julia> pairwise(Euclidean(), x, x)
1×1 Array{Float64,2}:
 7.45058e-9

julia> pairwise(Euclidean(1e-12), x, x)
1×1 Array{Float64,2}:
 0.0
```

## Benchmarks

The implementation has been carefully optimized based on benchmarks. The script in
`benchmark/benchmarks.jl` defines a benchmark suite for a variety of distances,
under column-wise and pairwise settings.

Here are benchmarks obtained running Julia 1.5 on a computer with a quad-core Intel
Core i5-2300K processor @ 3.2 GHz. Extended versions of the tables below can be
replicated using the script in `benchmark/print_table.jl`.

### Column-wise benchmark

Generically, column-wise distances are computed using a straightforward loop
implementation. For `[Sq]Mahalanobis`, however, specialized methods are
provided in *Distances.jl*, and the table below compares the performance
(measured in terms of average elapsed time of each iteration) of the generic
to the specialized implementation. The task in each iteration is to compute a
specific distance between corresponding columns in two `200-by-10000` matrices.

|  distance     | loop      |  colwise   |  gain       |
|---------------|-----------|------------|-------------|
| SqMahalanobis | 0.089470s |  0.014424s |  **6.2027** |
| Mahalanobis   | 0.090882s |  0.014096s |  **6.4475** |

### Pairwise benchmark

Generically, pairwise distances are computed using a straightforward loop
implementation. For distances of which a major part of the computation is a
quadratic form, however, the performance can be drastically improved by restructuring
the computation and delegating the core part to `GEMM` in *BLAS*. The table below
compares the performance (measured in terms of average elapsed time of each
iteration) of generic to the specialized implementations provided in *Distances.jl*.
The task in each iteration is to compute a specific distance in a pairwise manner
between columns in a `100-by-200` and `100-by-250` matrices, which will result in
a `200-by-250` distance matrix.

|  distance             |  loop     |  pairwise  |  gain  |
|---------------------- | --------- | -----------| -------|
| SqEuclidean           | 0.001273s |  0.000124s | **10.2290** |
| Euclidean             | 0.001445s |  0.000194s |  **7.4529** |
| CosineDist            | 0.001928s |  0.000149s | **12.9543** |
| CorrDist              | 0.016837s |  0.000187s | **90.1854** |
| WeightedSqEuclidean   | 0.001603s |  0.000143s | **11.2119** |
| WeightedEuclidean     | 0.001811s |  0.000238s |  **7.6032** |
| SqMahalanobis         | 0.308990s |  0.000248s | **1248.1892** |
| Mahalanobis           | 0.313415s |  0.000346s | **906.1836** |

# Bhattacharyya distances. Much like for KLDivergence we assume the vectors to
# be compared are probability distributions, frequencies or counts rather than
# vectors of samples. Pre-calc accordingly if you have samples.

struct BhattacharyyaDist <: SemiMetric end

struct HellingerDist <: Metric end


# Bhattacharyya coefficient

function bhattacharyya_coeff(a, b)
    n = length(a)
    if n != length(b)
        throw(DimensionMismatch("first argument has length $n which does not match the length of the second, $(length(b))."))
    end
    sqab, asum, bsum = _bhattacharyya_coeff(a, b)
    # We must normalize since we cannot assume that the vectors are normalized to probability vectors.
    return sqab / sqrt(asum * bsum)
end

@inline function _bhattacharyya_coeff(a, b)
    Ta = _eltype(a)
    Tb = _eltype(b)
    T = typeof(sqrt(zero(promote_type(Ta, Tb))))
    sqab = zero(T)
    asum = zero(Ta)
    bsum = zero(Tb)

    for (ai, bi) in zip(a, b)
        sqab += sqrt(ai * bi)
        asum += ai
        bsum += bi
    end
    return sqab, asum, bsum
end
@inline function _bhattacharyya_coeff(a::AbstractVector, b::AbstractVector)
    T = typeof(sqrt(oneunit(eltype(a))*oneunit(eltype(b))))
    sqab = zero(T)
    asum = zero(eltype(a))
    bsum = zero(eltype(b))

    @simd for i in eachindex(a, b)
        @inbounds ai = a[i]
        @inbounds bi = b[i]
        sqab += sqrt(ai * bi)
        asum += ai
        bsum += bi
    end
    return sqab, asum, bsum
end

# Faster pair- and column-wise versions TBD...


# Bhattacharyya distance
(::BhattacharyyaDist)(a, b) = -log(bhattacharyya_coeff(a, b))
const bhattacharyya = BhattacharyyaDist()

# Hellinger distance
(::HellingerDist)(a, b) = sqrt(1 - bhattacharyya_coeff(a, b))
const hellinger = HellingerDist()

# Common utilities

###########################################################
#
#   helper functions for dimension checking
#
###########################################################

function get_common_ncols(a::AbstractMatrix, b::AbstractMatrix)
    na = size(a, 2)
    size(b, 2) == na || throw(DimensionMismatch("The number of columns in a and b must match."))
    return na
end

function get_common_length(a, b)
    n = length(a)
    length(b) == n || throw(DimensionMismatch("The lengths of a and b must match."))
    return n
end

function get_pairwise_dims(r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    ma, na = size(a)
    mb, nb = size(b)
    ma == mb || throw(DimensionMismatch("The numbers of rows or columns in a and b must match."))
    size(r) == (na, nb) || throw(DimensionMismatch("Incorrect size of r."))
    return (ma, na, nb)
end

function get_pairwise_dims(r::AbstractMatrix, a::AbstractMatrix)
    m, n = size(a)
    size(r) == (n, n) || throw(DimensionMismatch("Incorrect size of r."))
    return (m, n)
end


# for metrics with fixed dimension (e.g. weighted metrics)

function get_colwise_dims(d::Int, r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    size(a, 1) == size(b, 1) == d ||
        throw(DimensionMismatch("Incorrect vector dimensions."))
    length(r) == size(a, 2) || throw(DimensionMismatch("Incorrect size of r."))
    return size(a)
end

function get_colwise_dims(d::Int, r::AbstractArray, a::AbstractVector, b::AbstractMatrix)
    length(a) == size(b, 1) == d ||
        throw(DimensionMismatch("Incorrect vector dimensions."))
    length(r) == size(b, 2) || throw(DimensionMismatch("Incorrect size of r."))
    return size(b)
end

function get_colwise_dims(d::Int, r::AbstractArray, a::AbstractMatrix, b::AbstractVector)
    size(a, 1) == length(b) == d ||
        throw(DimensionMismatch("Incorrect vector dimensions."))
    length(r) == size(a, 2) || throw(DimensionMismatch("Incorrect size of r."))
    return size(a)
end

function get_pairwise_dims(d::Int, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    na = size(a, 2)
    nb = size(b, 2)
    size(a, 1) == size(b, 1) == d || throw(DimensionMismatch("Incorrect vector dimensions."))
    size(r) == (na, nb) || throw(DimensionMismatch("Incorrect size of r."))
    return (d, na, nb)
end

function get_pairwise_dims(d::Int, r::AbstractMatrix, a::AbstractMatrix)
    n = size(a, 2)
    size(a, 1) == d || throw(DimensionMismatch("Incorrect vector dimensions."))
    size(r) == (n, n) || throw(DimensionMismatch("Incorrect size of r."))
    return (d, n)
end

###########################################################
#
#   calculation
#
###########################################################

function sqrt!(a::AbstractArray)
    @simd for i in eachindex(a)
        @inbounds a[i] = sqrt(a[i])
    end
    a
end

function norm_percol(a::AbstractMatrix{T}) where {T}
    n = size(a, 2)
    r = Vector{float(T)}(undef, n)
    @simd for j in 1:n
        aj = view(a, :, j)
        r[j] = sqrt(dot(aj, aj))
    end
    return r
end

function wsumsq_percol(w::AbstractArray, a::AbstractMatrix)
    m = size(a, 1)
    n = size(a, 2)
    T = typeof(zero(eltype(w)) * abs2(zero(eltype(a))))
    r = Vector{T}(undef, n)
    for j = 1:n
        aj = view(a, :, j)
        s = zero(T)
        @simd for i = 1:m
            @inbounds s += w[i] * abs2(aj[i])
        end
        r[j] = s
    end
    return r
end

function dot_percol!(r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    m = size(a, 1)
    n = size(a, 2)
    size(b) == (m, n) && length(r) == n ||
        throw(DimensionMismatch("Inconsistent array dimensions."))
    for j = 1:n
        aj = view(a, :, j)
        bj = view(b, :, j)
        r[j] = dot(aj, bj)
    end
    return r
end

dot_percol(a::AbstractMatrix, b::AbstractMatrix) = dot_percol!(Vector{Float64}(undef, size(a, 2)), a, b)

# Unit tests for Distances

using SparseArrays: sparsevec, sprand

struct FooDist <: PreMetric end # Julia 1.0 Compat: struct definition must be put in global scope

@testset "result_type" begin
    foodist(a, b) = a + b
    (::FooDist)(a, b) = foodist(a, b)
    for (Ta, Tb) in [
        (Int, Int),
        (Int, Float64),
        (Float32, Float32),
        (Float32, Float64),
    ]
        A, B = rand(Ta, 2, 3), rand(Tb, 2, 3)
        @test result_type(FooDist(), A, B) == result_type(FooDist(), Ta, Tb)
        @test result_type(foodist, A, B) == result_type(foodist, Ta, Tb) == typeof(foodist(oneunit(Ta), oneunit(Tb)))

        a, b = rand(Ta), rand(Tb)
        @test result_type(FooDist(), a, b) == result_type(FooDist(), Ta, Tb)
        @test result_type(foodist, a, b) == result_type(foodist, Ta, Tb) == typeof(foodist(oneunit(Ta), oneunit(Tb)))
    end
end

function test_metricity(dist, x, y, z)
    @testset "Test metricity of $(typeof(dist))" begin
        @test dist(x, y) == evaluate(dist, x, y)

        dxy = dist(x, y)
        dxz = dist(x, z)
        dyz = dist(y, z)
        if isa(dist, PreMetric)
            # Unfortunately small non-zero numbers (~10^-16) are appearing
            # in our tests due to accumulating floating point rounding errors.
            # We either need to allow small errors in our tests or change the
            # way we do accumulations...
            @test dist(x, x) + one(eltype(x)) ≈ one(eltype(x))
            @test dist(y, y) + one(eltype(y)) ≈ one(eltype(y))
            @test dist(z, z) + one(eltype(z)) ≈ one(eltype(z))
            @test dxy ≥ zero(eltype(x))
            @test dxz ≥ zero(eltype(x))
            @test dyz ≥ zero(eltype(x))
        end
        if isa(dist, SemiMetric)
            @test dxy ≈ dist(y, x)
            @test dxz ≈ dist(z, x)
            @test dyz ≈ dist(y, z)
        else # Not symmetric, so more PreMetric tests
            @test dist(y, x) ≥ zero(eltype(x))
            @test dist(z, x) ≥ zero(eltype(x))
            @test dist(z, y) ≥ zero(eltype(x))
        end
        if isa(dist, Metric)
            # Again we have small rounding errors in accumulations
            @test dxz ≤ dxy + dyz || dxz ≈ dxy + dyz
            dyx = dist(y, x)
            @test dyz ≤ dyx + dxz || dyz ≈ dyx + dxz
            dzy = dist(z, y)
            @test dxy ≤ dxz + dzy || dxy ≈ dxz + dzy
        end
    end
end

function test_batch(dist, _x, _y, args=(); Tins=(Float32, Float64), Touts=Tins)
    _xs = hcat(_x, _x)
    _ys = hcat(_y, _y)

    for (Tin, Tout) in zip(Tins, Touts)
        x, y = Tin.(_x), Tin.(_y)
        xs, ys = Tin.(_xs), Tin.(_ys)

        # Instantiate using `args` if not already instantiated.
        d = if dist isa PreMetric
            dist
        else
            dist(map(a -> Tin.(a), args)...)
        end

        # Ensure that `result_type` preserves the type.
        @test result_type(d, xs, ys) === Tout

        # Ensure that `pairwise` preserves the type,
        # e.g. if someone decides to implement their own.
        colpairs = pairwise(d, xs, ys; dims=2)
        @test eltype(colpairs) === Tout
        @test all(colpairs .== d(x, y))

        cols = colwise(d, xs, ys)
        @test eltype(cols) === Tout
        @test all(cols .== d(x, y))
    end
end

@testset "PreMetric, SemiMetric, Metric on $T" for T in (Float64, F64)
    Random.seed!(123)
    n = 100
    x = rand(T, n)
    y = rand(T, n)
    z = rand(T, n)

    test_metricity(SqEuclidean(), x, y, z)
    test_metricity(Euclidean(), x, y, z)
    test_metricity(Cityblock(), x, y, z)
    test_metricity(TotalVariation(), x, y, z)
    test_metricity(Chebyshev(), x, y, z)
    test_metricity(Minkowski(2.5), x, y, z)

    test_metricity(CosineDist(), x, y, z)
    test_metricity(CorrDist(), x, y, z)

    test_metricity(ChiSqDist(), x, y, z)

    test_metricity(Jaccard(), x, y, z)
    test_metricity(SpanNormDist(), x, y, z)

    test_metricity(BhattacharyyaDist(), x, y, z)
    test_metricity(HellingerDist(), x, y, z)
    test_metricity(Bregman(x -> sqeuclidean(x, zero(x)), x -> 2*x), x, y, z);


    x₁ = rand(T, 2)
    x₂ = rand(T, 2)
    x₃ = rand(T, 2)

    test_metricity(Haversine(6371.0), x₁, x₂, x₃)
    test_metricity(SphericalAngle(), x₁, x₂, x₃)

    k = rand(1:3, n)
    l = rand(1:3, n)
    m = rand(1:3, n)

    test_metricity(Hamming(), k, l, m)

    a = rand(Bool, n)
    b = rand(Bool, n)
    c = rand(Bool, n)

    test_metricity(RogersTanimoto(), a, b, c)
    test_metricity(BrayCurtis(), a, b, c)
    test_metricity(Jaccard(), a, b, c)

    for w in (rand(T, n), (rand(T, n)...,))
        test_metricity(PeriodicEuclidean(w), x, y, z)
        test_metricity(WeightedSqEuclidean(w), x, y, z)
        test_metricity(WeightedEuclidean(w), x, y, z)
        test_metricity(WeightedCityblock(w), x, y, z)
        test_metricity(WeightedMinkowski(w, 2.5), x, y, z)
        test_metricity(WeightedHamming(w), a, b, c)
    end

    Q = rand(T, n, n)
    Q = Q * Q'  # make sure Q is positive-definite

    test_metricity(SqMahalanobis(Q), x, y, z)
    test_metricity(Mahalanobis(Q), x, y, z)

    p = rand(T, n)
    q = rand(T, n)
    r = rand(T, n)
    p[p .< median(p)] .= 0
    p /= sum(p)
    q /= sum(q)
    r /= sum(r)

    test_metricity(KLDivergence(), p, q, r)
    test_metricity(RenyiDivergence(0.0), p, q, r)
    test_metricity(RenyiDivergence(1.0), p, q, r)
    test_metricity(RenyiDivergence(Inf), p, q, r)
    test_metricity(RenyiDivergence(0.5), p, q, r)
    test_metricity(RenyiDivergence(2), p, q, r)
    test_metricity(RenyiDivergence(10), p, q, r)
    test_metricity(JSDivergence(), p, q, r)
end

@testset "individual metrics" begin
    a = 1
    b = 2
    @test sqeuclidean(a, b) === 1
    @test euclidean(a, b) === 1.0
    @test jaccard(a, b) === 0.5
    @test cityblock(a, b) === 1
    @test totalvariation(a, b) === 0.5
    @test chebyshev(a, b) == 1.0
    @test braycurtis(a, b) === 1/3
    @test minkowski(a, b, 2) == 1.0
    @test hamming(a, b) === 1
    @test hamming("martha", "marhta") === 2
    @test hamming("es an ", " vs an") === 6
    @test hamming("", "") === 0
    @test peuclidean(a, b, 0.5) === 0.0
    @test peuclidean(a, b, 2) === 1.0
    @test cosine_dist(a, b) === 0.0
    @test bhattacharyya(a, b) === bhattacharyya([a], [b]) === -0.0
    @test bhattacharyya(a, b) === bhattacharyya((a,), (b,))
    @test isnan(corr_dist(a, b))
    @test spannorm_dist(a, b) === 0

    bt = [true, false, true]
    bf = [false, true, true]
    @test rogerstanimoto(bt, bf) == 4.0 / 5.0
    @test braycurtis(bt, bf) == 0.5
    b1 = [true, false, false]
    b2 = [false, true, false]
    @test rogerstanimoto(b1, b2) == 4.0 / 5.0
    b1 = [true, false, false]
    b2 = [true,  true, false]
    @test rogerstanimoto(b1, b2) == 1.0 / 2.0

    for w in (2, (2,))
        @test wsqeuclidean(a, b, w) === 2
        @test weuclidean(a, b, w) === sqrt(2)
        @test wcityblock(a, b, w) === 2
        @test wminkowski(a, b, w, 2) === sqrt(2)
        @test whamming(a, b, w) === 2
    end

    for T in (Float64, F64)
        for (_x, _y) in (([4.0, 5.0, 6.0, 7.0], [3.0, 9.0, 8.0, 1.0]),
                         ([4.0, 5.0, 6.0, 7.0], [3. 8.; 9. 1.0]))
            x, y = T.(_x), T.(_y)
            for (x, y) in ((x, y), (sparsevec(x), sparsevec(y)),
                           (convert(Array{Union{Missing, T}}, x), convert(Array{Union{Missing, T}}, y)),
                           ((Iterators.take(x, 4), Iterators.take(y, 4))), # iterator
                           (((x[i] for i in eachindex(x)), (y[i] for i in eachindex(y)))), # generator
                          )
                xc, yc = collect(x), collect(y)
                @test sqeuclidean(x, y) == 57.0
                @test euclidean(x, y) == sqrt(57.0)
                @test jaccard(x, y) == 13.0 / 28
                @test cityblock(x, y) == 13.0
                @test totalvariation(x, y) == 6.5
                @test chebyshev(x, y) == 6.0
                @test braycurtis(x, y) == 1.0 - (30.0 / 43.0)
                @test minkowski(x, y, 2) == sqrt(57.0)
                @test peuclidean(x, y, fill(10.0, 4)) == sqrt(37)
                @test peuclidean(xc - vec(yc), zero(yc), fill(10.0, 4)) == peuclidean(x, y, fill(10.0, 4))
                @test peuclidean(x, y, [10.0, 10.0, 10.0, Inf]) == sqrt(57)
                @test_throws DimensionMismatch cosine_dist(1.0:2, 1.0:3)
                @test cosine_dist(x, y) ≈ (1.0 - 112. / sqrt(19530.0))
                x_int, y_int = Int64.(x), Int64.(y)
                @test cosine_dist(x_int, y_int) == (1.0 - 112.0 / sqrt(19530.0))
                @test corr_dist(x, y) ≈ cosine_dist(x .- mean(x), vec(yc) .- mean(y))
                @test corr_dist(OffsetVector(xc, eachindex(xc).-2), yc) == corr_dist(x, y)
                @test chisq_dist(x, y) == sum((xc - vec(yc)).^2 ./ (xc + vec(yc)))
                @test spannorm_dist(x, y) == maximum(xc - vec(yc)) - minimum(xc - vec(yc))
                @test kl_divergence(x, y) ≈ sum(xc[i] * log(xc[i] / yc[i]) for i in eachindex(xc, yc))
                @test gkl_divergence(x, y) ≈ sum(xc[i] * log(xc[i] / yc[i]) - xc[i] + yc[i] for i in eachindex(xc, yc))
                @test bhattacharyya(x, y) == bhattacharyya(xc, yc)
                @test meanad(x, y) ≈ mean(Float64[abs(xc[i] - yc[i]) for i in eachindex(xc, yc)])
                @test msd(x, y) ≈ mean(Float64[abs2(xc[i] - yc[i]) for i in eachindex(xc, yc)])
                @test rmsd(x, y) ≈ sqrt(msd(x, y))
                @test nrmsd(x, y) ≈ sqrt(msd(x, y)) / (maximum(x) - minimum(x))

                w = ones(4)
                @test sqeuclidean(x, y) ≈ wsqeuclidean(x, y, w)

                w = rand(Float64, length(x))
                @test wsqeuclidean(x, y, w) ≈ dot((xc - vec(yc)).^2, w)
                @test weuclidean(x, y, w) ≈ sqrt(wsqeuclidean(x, y, w))
                @test wcityblock(x, y, w) ≈ dot(abs.(xc - vec(yc)), w)
                @test wminkowski(x, y, w, 2) ≈ weuclidean(x, y, w)
            end
        end

        # Test ChiSq doesn't give NaN at zero
        @test chisq_dist([0.0], [0.0]) == 0.0

        # Test weighted Hamming distances with even weights
        a = T.([1.0, 2.0, 1.0, 3.0, 2.0, 1.0])
        b = T.([1.0, 3.0, 0.0, 2.0, 2.0, 0.0])
        w = rand(T, size(a))

        @test whamming(a, a, w) === T(0.0)
        @test whamming(a, b, w) ≈ (a .≠ b) ⋅ w

        # Minimal test of Jaccard - test return type stability.
        @inferred Jaccard()(rand(T, 3), rand(T, 3))
        @inferred Jaccard()([1, 2, 3], [1, 2, 3])
        @inferred Jaccard()([true, false, true], [false, true, true])

        # Test Bray-Curtis. Should be 1 if no elements are shared, 0 if all are the same
        @test braycurtis([1,0,3],[0,1,0]) == 1.0
        @test braycurtis(rand(10), zeros(10)) == 1.0
        @test braycurtis([1,0],[1,0]) == 0.0

        # Test KL, Renyi and JS divergences
        r = rand(T, 12)
        p = copy(r)
        p[p .< median(p)] .= 0.0
        scale = sum(p) / sum(r)
        r /= sum(r)
        p /= sum(p)
        q = rand(T, 12)
        q /= sum(q)

        klv = 0.0
        for i in eachindex(p, q)
            if p[i] > 0
                klv += p[i] * log(p[i] / q[i])
            end
        end

        pm = (p + q) / 2
        for (r, p, pm) in ((r, p, pm),
                           (Iterators.take(r, length(r)), Iterators.take(p, length(p)), Iterators.take(pm, length(pm))),
                           ((r[i] for i in eachindex(r)), (p[i] for i in eachindex(p)), (pm[i] for i in eachindex(pm))),
                          )
            @test kl_divergence(p, q) ≈ klv
            @test typeof(kl_divergence(p, q)) == T

            @test renyi_divergence(p, r, 0) ≈ -log(scale)
            @test renyi_divergence(p, r, 1) ≈ -log(scale)
            @test renyi_divergence(p, r, 10) ≈ -log(scale)
            @test renyi_divergence(p, r, rand()) ≈ -log(scale)
            @test renyi_divergence(p, r, Inf) ≈ -log(scale)
            @test isinf(renyi_divergence([0.0, 0.5, 0.5], [0.0, 1.0, 0.0], Inf))
            @test renyi_divergence([0.0, 1.0, 0.0], [0.0, 0.5, 0.5], Inf) ≈ log(2.0)
            @test renyi_divergence(p, q, 1) ≈ kl_divergence(p, q)

            jsv = kl_divergence(p, pm) / 2 + kl_divergence(q, pm) / 2
            @test js_divergence(p, q) ≈ jsv
        end
    end
end # testset

@testset "NaN behavior" begin
    a = [NaN, 0]; b = [0, NaN]
    @test isnan(chebyshev(a, b)) == isnan(maximum(a - b))
    a = [NaN, 0]; b = [0, 1]
    @test isnan(chebyshev(a, b)) == isnan(maximum(a - b))
    @test isnan(renyi_divergence([0.5, 0.0, 0.5], [0.5, 0.5, NaN], 2))
    @test isnan(kl_divergence([0.5, 0.0, 0.5], [0.5, 0.5, NaN]))
    @test isnan(gkl_divergence([0.5, 0.0, 0.5], [0.5, 0.5, NaN]))
    @test isnan(js_divergence([0.5, 0.0, 0.5], [0.5, 0.5, NaN]))
end #testset

@testset "empty vector" begin
    for T in (Float64, F64), (a, b) in ((T[], T[]), (Iterators.take(T[], 0), Iterators.take(T[], 0)),
                                        (sprand(T, 0, .1), sprand(T, 0, .1)))
        @test sqeuclidean(a, b) == 0.0
        @test isa(sqeuclidean(a, b), T)
        @test euclidean(a, b) == 0.0
        @test isa(euclidean(a, b), T)
        @test cityblock(a, b) == 0.0
        @test isa(cityblock(a, b), T)
        @test totalvariation(a, b) == 0.0
        @test isa(totalvariation(a, b), T)
        @test chebyshev(a, b) == 0.0
        @test isa(chebyshev(a, b), T)
        @test braycurtis(a, b) == 0.0
        @test isa(braycurtis(a, b), T)
        @test minkowski(a, b, 2) == 0.0
        @test isa(minkowski(a, b, 2), T)
        @test hamming(a, b) == 0.0
        @test isa(hamming(a, b), Int)
        @test renyi_divergence(a, b, 1.0) == 0.0
        @test isa(renyi_divergence(a, b, 2.0), T)
        @test braycurtis(a, b) == 0.0
        @test isa(braycurtis(a, b), T)

        w = T[]
        @test isa(whamming(a, b, w), T)
        @test peuclidean(a, b, w) == 0.0
        @test isa(peuclidean(a, b, w), T)
    end
end # testset

@testset "DimensionMismatch throwing" begin
    a = 1.0:2; b = 1:3.0
    @test_throws DimensionMismatch cosine_dist(a, b)
    @test_throws DimensionMismatch kl_divergence(a, b)
    @test_throws DimensionMismatch gkl_divergence(a, b)
    @test_throws DimensionMismatch js_divergence(a, b)
    @test_throws DimensionMismatch renyi_divergence(a, b, 1.0)
    a = [1, 0]; b = [2]
    @test_throws DimensionMismatch sqeuclidean(a, b)
    a = (1, 0); b = (2,)
    @test_throws DimensionMismatch sqeuclidean(a, b)
    a = (1, 0); b = (2.0,); w = (3.0,)
    @test_throws DimensionMismatch wsqeuclidean(a, b, w)
    @test_throws DimensionMismatch peuclidean(a, b, w)
    a = [1, 0]; b = [2.0, 4.0] ; w = [3.0]
    @test_throws DimensionMismatch wsqeuclidean(a, b, w)
    @test_throws DimensionMismatch peuclidean(a, b, w)
    a = (1, 0); b = (2.0, 4.0) ; w = (3.0,)
    @test_throws DimensionMismatch wsqeuclidean(a, b, w)
    @test_throws DimensionMismatch peuclidean(a, b, w)
    p = [0.5, 0.5]; q = [0.3, 0.3, 0.4]
    @test_throws DimensionMismatch bhattacharyya(p, q)
    @test_throws DimensionMismatch hellinger(q, p)
    Q = rand(length(p), length(p))
    Q = Q * Q'  # make sure Q is positive-definite
    @test_throws DimensionMismatch mahalanobis(p, q, Q)
    @test_throws DimensionMismatch mahalanobis(q, q, Q)
    @test_throws DimensionMismatch sqmahalanobis(p, q, Q)
    @test_throws DimensionMismatch sqmahalanobis(q, q, Q)
    mat23 = [0.3 0.2 0.0; 0.1 0.0 0.4]
    mat22 = [0.3 0.2; 0.1 0.4]
    @test_throws DimensionMismatch colwise!(Euclidean(), mat23, mat23, mat23)
    @test_throws DimensionMismatch colwise!(Euclidean(), mat23, mat23, q)
    @test_throws DimensionMismatch colwise!(Euclidean(), mat23, mat23, mat22)
    @test_throws DimensionMismatch colwise!(Bregman(x -> sqeuclidean(x, zero(x)), x -> 2*x), mat23, mat23, mat22)
    @test_throws DimensionMismatch Bregman(x -> sqeuclidean(x, zero(x)), x -> 2*x)([1, 2, 3], [1, 2])
    @test_throws DimensionMismatch Bregman(x -> sqeuclidean(x, zero(x)), x -> [1, 2])([1, 2, 3], [1, 2, 3])
    sv1 = sprand(10, .2)
    sv2 = sprand(20, .2)
    @test_throws DimensionMismatch euclidean(sv1, sv2)
    @test_throws DimensionMismatch bhattacharyya(sv1, sv2)
end # testset

@testset "Different input types" begin
    for (x, y) in (([4, 5, 6, 7], [3.0, 9.0, 8.0, 1.0]),
                   ([4, 5, 6, 7], [3//1 8; 9 1]))
        @test (@inferred sqeuclidean(x, y)) == 57
        @test (@inferred euclidean(x, y)) == sqrt(57)
        @test (@inferred jaccard(x, y)) == convert(Base.promote_eltype(x, y), 13 // 28)
        @test (@inferred cityblock(x, y)) == 13
        @test (@inferred totalvariation(x, y)) == 6.5
        @test (@inferred chebyshev(x, y)) == 6
        @test (@inferred braycurtis(x, y)) == convert(Base.promote_eltype(x, y), 13 // 43)
        @test (@inferred minkowski(x, y, 2)) == sqrt(57)
        @test (@inferred peuclidean(x, y, fill(10, 4))) == sqrt(37)
        @test (@inferred peuclidean(x - vec(y), zero(y), fill(10, 4))) == peuclidean(x, y, fill(10, 4))
        @test (@inferred peuclidean(x, y, [10.0, 10.0, 10.0, Inf])) == sqrt(57)
        @test (@inferred cosine_dist(x, y)) ≈ (1 - 112 / sqrt(19530))
        @test (@inferred corr_dist(x, y)) ≈ cosine_dist(x .- mean(x), vec(y) .- mean(y))
        @test (@inferred chisq_dist(x, y)) == sum((x - vec(y)).^2 ./ (x + vec(y)))
        @test (@inferred spannorm_dist(x, y)) == maximum(x - vec(y)) - minimum(x - vec(y))
        @test (@inferred kl_divergence(x, y)) ≈ sum(x[i] * log(x[i] / y[i]) for i in eachindex(x, y))
        @test (@inferred gkl_divergence(x, y)) ≈ sum(x[i] * log(x[i] / y[i]) - x[i] + y[i] for i in eachindex(x, y))
        @test (@inferred meanad(x, y)) ≈ mean(Float64[abs(x[i] - y[i]) for i in eachindex(x, y)])
        @test (@inferred msd(x, y)) ≈ mean(Float64[abs2(x[i] - y[i]) for i in eachindex(x, y)])
        @test (@inferred rmsd(x, y)) ≈ sqrt(msd(x, y))
        @test (@inferred nrmsd(x, y)) ≈ sqrt(msd(x, y)) / (maximum(x) - minimum(x))

        w = ones(Int, 4)
        @test sqeuclidean(x, y) ≈ wsqeuclidean(x, y, w)

        w = rand(eachindex(x), size(x))
        @test (@inferred wsqeuclidean(x, y, w)) ≈ dot((x - vec(y)).^2, w)
        @test (@inferred weuclidean(x, y, w)) == sqrt(wsqeuclidean(x, y, w))
        @test (@inferred wcityblock(x, y, w)) ≈ dot(abs.(x - vec(y)), w)
        @test (@inferred wminkowski(x, y, w, 2)) ≈ weuclidean(x, y, w)
    end
end

@testset "mahalanobis" begin
    for T in (Float64, F64, ComplexF64)
        x, y = T.([4.0, 5.0, 6.0, 7.0]), T.([3.0, 9.0, 8.0, 1.0])

        Q = rand(T, length(x), length(x))
        Q = Q * Q'  # make sure Q is positive-definite
        for Q in (Q, T <: Complex ? Hermitian(Q) : Symmetric(Q))
            @test sqmahalanobis(x, y, Q) ≈ dot(x - y, Q * (x - y))
            @test eltype(sqmahalanobis(x, y, Q)) == T
            @test mahalanobis(x, y, Q) == sqrt(sqmahalanobis(x, y, Q))
            @test eltype(mahalanobis(x, y, Q)) == T
        end
        A = rand(T, length(x), length(x))
        S = A + A' - I
        # TODO: let Distances.jl throw in next breaking release
        # @test_throws ArgumentError SqMahalanobis(A)
        @test_logs (:warn, "matrix is not positive semidefinite") SqMahalanobis(S)
        # TODO: let Distances.jl throw in next breaking release
        # @test_throws ArgumentError Mahalanobis(A)
        @test_logs (:warn, "matrix is not positive semidefinite") Mahalanobis(S)
        # test that semiposdef'ness can be overwritten, avoiding all checks
        @test_logs (:warn, "matrix is not symmetric/Hermitian") SqMahalanobis(A, skipchecks=true)
        @test SqMahalanobis(A, skipchecks=true) isa SemiMetric
        @test_logs (:warn, "matrix is not symmetric/Hermitian") Mahalanobis(A, skipchecks=true)
        @test Mahalanobis(A, skipchecks=true) isa Metric
        @test SqMahalanobis(S, skipchecks=true) isa SemiMetric
        @test Mahalanobis(S, skipchecks=true) isa Metric
    end
end #testset

@testset "haversine" begin
    let x = [1.,-15.625], y = [-179.,15.625]
        # Type used in default constructor should work for both `Float32` and `Float64`.
        test_batch(Haversine(), x, y)

        # `Float32` should be promoted to `Float64`.
        test_batch(Haversine{Float32}(), x, y)

        # `Haversine(T(radius))` should result in `T` when inputs also has eltype `T`.
        test_batch(Haversine, x, y, (6_371_000, ))
    end

    for T in (Float64, F64)
        @test haversine([-180.,0.], [180.,0.], 1.) ≈ 0 atol=1e-10
        @test haversine([0.,-90.],  [0.,90.],  1.) ≈ π atol=1e-10
        @test haversine((-180.,0.), (180.,0.), 1.) ≈ 0 atol=1e-10
        @test haversine((0.,-90.),  (0.,90.),  1.) ≈ π atol=1e-10
        x, y = (1.,-15.625), (-179.,15.625)
        @test haversine(x, y, 6371.) ≈ 20015 atol=1e-1
        @test haversine(x, y) ≈ 20015086 rtol=1e-7
        @test Haversine()(x, y) ≈ 20015086 rtol=1e-7
        @test haversine(Float32.(x), Float32.(y)) isa Float32
        @test haversine(Iterators.take(x, 2), Iterators.take(y, 2), 6371.) ≈ 20015 atol=1e-1
        @test_throws ArgumentError haversine([0.,-90., 0.25], [0.,90.], 1.)
        x, y = (1.0°,-15.625°), (-179.0°,15.625°)
        @test haversine(x, y, 6371.0km) ≈ 20015km atol=1e-1km
    end
end

@testset "spherical angle" begin
    @test spherical_angle([-π, 0],    [π,0]) ≈ 0 atol=1e-10
    @test spherical_angle([0,-π/2], [0,π/2]) ≈ π atol=1e-10
    @test spherical_angle((-π,0),     (π,0)) ≈ 0 atol=1e-10
    @test spherical_angle((0,-π/2), (0,π/2)) ≈ π atol=1e-10
    x, y = rand(2), rand(2)
    x_deg, y_deg = rad2deg.(x), rad2deg.(y)
    @test spherical_angle(x, y) ≈ haversine(x_deg, y_deg, 1) atol=1e-10
    @test spherical_angle(Iterators.take(x, 2), Iterators.take(y, 2)) ≈ haversine(x_deg, y_deg, 1) atol=1e-10
    @test_throws ArgumentError spherical_angle([0.,-π/2, 0.25], [0.,π/2])
end

@testset "bhattacharyya / hellinger" begin
    for T in (Int, Float64, F64)
        _x, _y = T.([4, 5, 6, 7]), T.([3, 9, 8, 1])
        _a = T.([1, 2, 1, 3, 2, 1])
        _b = T.([1, 3, 0, 2, 2, 0])
        _p = T == Int ? rand(0:10, 12) : rand(T, 12)
        _p[_p .< median(_p)] .= 0
        _q = T == Int ? rand(0:10, 12) : rand(T, 12)

        for (x, y, a, b, p, q) in ((_x, _y, _a, _b, _p, _q), sparsevec.((_x, _y, _a, _b, _p, _q)))
            # Bhattacharyya and Hellinger distances are defined for discrete
            # probability distributions so to calculate the expected values
            # we need to normalize vectors.
            px = x ./ sum(x)
            py = y ./ sum(y)
            expected_bc_x_y = sum(sqrt.(px .* py))
            for (x, y) in ((x, y), (Iterators.take(x, 12), Iterators.take(y, 12)))
                @test Distances.bhattacharyya_coeff(x, y) ≈ expected_bc_x_y
                @test bhattacharyya(x, y) ≈ (-log(expected_bc_x_y))
                @test hellinger(x, y) ≈ sqrt(1 - expected_bc_x_y)
            end

            pa = a ./ sum(a)
            pb = b ./ sum(b)
            expected_bc_a_b = sum(sqrt.(pa .* pb))
            @test Distances.bhattacharyya_coeff(a, b) ≈ expected_bc_a_b
            @test bhattacharyya(a, b) ≈ (-log(expected_bc_a_b))
            @test hellinger(a, b) ≈ sqrt(1 - expected_bc_a_b)

            pp = p ./ sum(p)
            pq = q ./ sum(q)
            expected_bc_p_q = sum(sqrt.(pp .* pq))
            @test Distances.bhattacharyya_coeff(p, q) ≈ expected_bc_p_q
            @test bhattacharyya(p, q) ≈ (-log(expected_bc_p_q))
            @test hellinger(p, q) ≈ sqrt(1 - expected_bc_p_q)

            # Ensure it is semimetric
            @test bhattacharyya(x, y) ≈ bhattacharyya(y, x)
        end
    end
end #testset


function test_colwise(dist, x, y, T)
    @testset "Colwise test for $(typeof(dist))" begin
        n = size(x, 2)
        r1 = zeros(T, n)
        r2 = zeros(T, n)
        r3 = zeros(T, n)
        r4 = zeros(T, 1, n)
        r5 = zeros(T, 1, n)
        for j = 1:n
            r1[j] = dist(x[:, j], y[:, j])
            r2[j] = dist(x[:, 1], y[:, j])
            r3[j] = dist(x[:, j], y[:, 1])
        end
        # ≈ and all( .≈ ) seem to behave slightly differently for F64
        @test all(colwise(dist, x, y) .≈ r1)
        @test all(colwise(dist, (x[:,i] for i in axes(x, 2)), (y[:,i] for i in axes(y, 2))) .≈ r1)
        
        @test colwise!(dist, r4, x, y) ≈ @test_deprecated(colwise!(r5, dist, x, y))
        @test r4 ≈ r5

        @test all(r4[i] ≈ r1[i] for i in 1:n)
        @test all(colwise(dist, x[:, 1], y) .≈ r2)
        @test all(colwise(dist, x, y[:, 1]) .≈ r3)
    end
end

@testset "column-wise metrics on $T" for T in (Float64, F64)
    m = 5
    n = 8
    X = rand(T, m, n)
    Y = rand(T, m, n)
    A = rand(1:3, m, n)
    B = rand(1:3, m, n)

    P = rand(T, m, n)
    Q = rand(T, m, n)
    # Make sure not to remove all of the non-zeros from any column
    for i in 1:n
        P[P[:, i] .< median(P[:, i]) / 2, i] .= 0.0
    end

    test_colwise(SqEuclidean(), X, Y, T)
    test_colwise(sqeuclidean, X, Y, T)
    test_colwise(Euclidean(), X, Y, T)
    test_colwise(euclidean, X, Y, T)
    test_colwise(Cityblock(), X, Y, T)
    test_colwise(cityblock, X, Y, T)
    test_colwise(TotalVariation(), X, Y, T)
    test_colwise(totalvariation, X, Y, T)
    test_colwise(Chebyshev(), X, Y, T)
    test_colwise(chebyshev, X, Y, T)
    test_colwise(Minkowski(2.5), X, Y, T)
    test_colwise(Hamming(), A, B, T)
    test_colwise(hamming, A, B, T)
    test_colwise(Bregman(x -> sqeuclidean(x, zero(x)), x -> 2*x), X, Y, T);

    test_colwise(CosineDist(), X, Y, T)
    test_colwise(cosine_dist, X, Y, T)
    test_colwise(CorrDist(), X, Y, T)
    test_colwise(corr_dist, X, Y, T)

    test_colwise(ChiSqDist(), X, Y, T)
    test_colwise(chisq_dist, X, Y, T)
    test_colwise(KLDivergence(), P, Q, T)
    test_colwise(kl_divergence, P, Q, T)
    test_colwise(GenKLDivergence(), P, Q, T)
    test_colwise(gkl_divergence, P, Q, T)
    test_colwise(RenyiDivergence(0.0), P, Q, T)
    test_colwise(RenyiDivergence(1.0), P, Q, T)
    test_colwise(RenyiDivergence(Inf), P, Q, T)
    test_colwise(RenyiDivergence(0.5), P, Q, T)
    test_colwise(RenyiDivergence(2), P, Q, T)
    test_colwise(RenyiDivergence(10), P, Q, T)
    test_colwise(JSDivergence(), P, Q, T)
    test_colwise(js_divergence, P, Q, T)
    test_colwise(SpanNormDist(), X, Y, T)
    test_colwise(spannorm_dist, X, Y, T)

    test_colwise(BhattacharyyaDist(), X, Y, T)
    test_colwise(bhattacharyya, X, Y, T)
    test_colwise(HellingerDist(), X, Y, T)
    test_colwise(hellinger, X, Y, T)
    test_colwise(BrayCurtis(), X, Y, T)
    test_colwise(braycurtis, X, Y, T)
    test_colwise(Jaccard(), X, Y, T)
    test_colwise(jaccard, X, Y, T)

    w = rand(T, m)

    test_colwise(WeightedSqEuclidean(w), X, Y, T)
    test_colwise(WeightedEuclidean(w), X, Y, T)
    test_colwise(WeightedCityblock(w), X, Y, T)
    test_colwise(WeightedMinkowski(w, 2.5), X, Y, T)
    test_colwise(WeightedHamming(w), A, B, T)
    test_colwise(PeriodicEuclidean(w), X, Y, T)

    Q = rand(T, m, m)
    Q = Q * Q'  # make sure Q is positive-definite

    test_colwise(SqMahalanobis(Q), X, Y, T)
    test_colwise(Mahalanobis(Q), X, Y, T)
end

function test_pairwise(dist, x, y, T)
    @testset "Pairwise test for $(typeof(dist))" begin
        nx = size(x, 2)
        ny = size(y, 2)
        rxy = zeros(T, nx, ny)
        rxx = zeros(T, nx, nx)
        for j = 1:ny, i = 1:nx
            rxy[i, j] = dist(x[:, i], y[:, j])
        end
        for j = 1:nx, i = 1:nx
            rxx[i, j] = dist(x[:, i], x[:, j])
        end
        # As earlier, we have small rounding errors in accumulations
        @test pairwise(dist, x, y, dims=2) ≈ rxy
        @test pairwise(dist, x, dims=2) ≈ rxx
        @test pairwise(dist, permutedims(x), permutedims(y), dims=1) ≈ rxy
        @test pairwise(dist, permutedims(x), dims=1) ≈ rxx

        # In-place computations
        rxy2 = zeros(T, nx, ny)
        @test @test_deprecated(pairwise!(rxy2, dist, x, y; dims=2)) ≈ rxy
        @test rxy2 ≈ rxy
        fill!(rxy2, zero(T))
        @test pairwise!(dist, rxy2, x, y; dims=2) ≈ rxy
        @test rxy2 ≈ rxy

        rxx2 = zeros(T, nx, nx)
        @test @test_deprecated(pairwise!(rxx2, dist, x; dims=2)) ≈ rxx
        @test rxx2 ≈ rxx
        fill!(rxx2, zero(T))
        @test pairwise!(dist, rxx2, x; dims=2) ≈ rxx
        @test rxx2 ≈ rxx

        fill!(rxy2, zero(T))
        @test @test_deprecated(pairwise!(rxy2, dist, permutedims(x), permutedims(y); dims=1)) ≈ rxy
        @test rxy2 ≈ rxy
        fill!(rxy2, zero(T))
        @test pairwise!(dist, rxy2, permutedims(x), permutedims(y); dims=1) ≈ rxy
        @test rxy2 ≈ rxy

        fill!(rxx2, zero(T))
        @test @test_deprecated(pairwise!(rxx2, dist, permutedims(x); dims=1)) ≈ rxx
        @test rxx2 ≈ rxx
        fill!(rxx2, zero(T))
        @test pairwise!(dist, rxx2, permutedims(x); dims=1) ≈ rxx
        @test rxx2 ≈ rxx

        # General arguments (iterators and vectors of vectors)
        vecx = (x[:, i] for i in 1:nx)
        vecy = (y[:, i] for i in 1:ny)
        for (vecx, vecy) in ((vecx, vecy), (collect(vecx), collect(vecy)))
            @test pairwise(dist, vecx, vecy) ≈ rxy
            @test pairwise(dist, vecx) ≈ rxx

            fill!(rxy2, zero(T))
            @test @test_deprecated(pairwise!(rxy2, dist, vecx, vecy)) ≈ rxy
            @test rxy2 ≈ rxy
            fill!(rxy2, zero(T))
            @test pairwise!(dist, rxy2, vecx, vecy) ≈ rxy
            @test rxy2 ≈ rxy

            fill!(rxx2, zero(T))
            @test @test_deprecated(pairwise!(rxx2, dist, vecx)) ≈ rxx
            @test rxx2 ≈ rxx
            fill!(rxx2, zero(T))
            @test pairwise!(dist, rxx2, vecx) ≈ rxx
            @test rxx2 ≈ rxx
        end
    end
end

@testset "pairwise metrics on $T" for T in (Float64, F64)
    m = 5
    n = 8
    nx = 6
    ny = 8

    X = rand(T, m, nx)
    Y = rand(T, m, ny)
    A = rand(1:3, m, nx)
    B = rand(1:3, m, ny)

    P = rand(T, m, nx)
    Q = rand(T, m, ny)

    test_pairwise(SqEuclidean(), X, Y, T)
    test_pairwise(sqeuclidean, X, Y, T)
    test_pairwise(Euclidean(), X, Y, T)
    test_pairwise(euclidean, X, Y, T)
    test_pairwise(Cityblock(), X, Y, T)
    test_pairwise(cityblock, X, Y, T)
    test_pairwise(TotalVariation(), X, Y, T)
    test_pairwise(totalvariation, X, Y, T)
    test_pairwise(MeanSqDeviation(), X, Y, T)
    test_pairwise(msd, X, Y, T)
    test_pairwise(RMSDeviation(), X, Y, T)
    test_pairwise(rmsd, X, Y, T)
    test_pairwise(NormRMSDeviation(), X, Y, T)
    test_pairwise(nrmsd, X, Y, T)
    test_pairwise(Chebyshev(), X, Y, T)
    test_pairwise(chebyshev, X, Y, T)
    test_pairwise(Minkowski(2.5), X, Y, T)
    test_pairwise(Hamming(), A, B, T)
    test_pairwise(hamming, A, B, T)

    test_pairwise(CosineDist(), X, Y, T)
    test_pairwise(cosine_dist, X, Y, T)
    test_pairwise(CosineDist(), A, B, T)
    test_pairwise(cosine_dist, A, B, T)
    test_pairwise(CorrDist(), X, Y, T)
    test_pairwise(corr_dist, X, Y, T)

    test_pairwise(ChiSqDist(), X, Y, T)
    test_pairwise(chisq_dist, X, Y, T)
    test_pairwise(KLDivergence(), P, Q, T)
    test_pairwise(kl_divergence, P, Q, T)
    test_pairwise(GenKLDivergence(), P, Q, T)
    test_pairwise(gkl_divergence, P, Q, T)
    test_pairwise(RenyiDivergence(0.0), P, Q, T)
    test_pairwise(RenyiDivergence(1.0), P, Q, T)
    test_pairwise(RenyiDivergence(Inf), P, Q, T)
    test_pairwise(RenyiDivergence(0.5), P, Q, T)
    test_pairwise(RenyiDivergence(2), P, Q, T)
    test_pairwise(JSDivergence(), P, Q, T)
    test_pairwise(js_divergence, P, Q, T)
    test_pairwise(SpanNormDist(), X, Y, T)
    test_pairwise(spannorm_dist, X, Y, T)

    test_pairwise(BhattacharyyaDist(), X, Y, T)
    test_pairwise(bhattacharyya, X, Y, T)
    test_pairwise(HellingerDist(), X, Y, T)
    test_pairwise(hellinger, X, Y, T)
    test_pairwise(BrayCurtis(), X, Y, T)
    test_pairwise(braycurtis, X, Y, T)
    test_pairwise(Jaccard(), X, Y, T)
    test_pairwise(jaccard, X, Y, T)
    test_pairwise(Bregman(x -> sqeuclidean(x, zero(x)), x -> 2*x), X, Y, T)

    w = rand(m)

    test_pairwise(WeightedSqEuclidean(w), X, Y, T)
    test_pairwise(WeightedEuclidean(w), X, Y, T)
    test_pairwise(WeightedCityblock(w), X, Y, T)
    test_pairwise(WeightedMinkowski(w, 2.5), X, Y, T)
    test_pairwise(WeightedHamming(w), A, B, T)
    test_pairwise(PeriodicEuclidean(w), X, Y, T)

    Q = rand(m, m)
    Q = Q * Q'  # make sure Q is positive-definite

    test_pairwise(SqMahalanobis(Q), X, Y, T)
    test_pairwise(Mahalanobis(Q), X, Y, T)

    m, nx, ny = 2, 8, 6

    X = rand(T, m, nx)
    Y = rand(T, m, ny)
    test_pairwise(Haversine(), X, Y, T)
    test_pairwise(SphericalAngle(), X, Y, T)
    test_pairwise(spherical_angle, X, Y, T)
end

@testset "pairwise metrics on complex arrays" begin
    m = 5
    n = 8
    nx = 6
    ny = 8

    X = rand(ComplexF64, m, nx)
    Y = rand(ComplexF64, m, ny)

    test_pairwise(SqEuclidean(), X, Y, Float64)
    test_pairwise(Euclidean(), X, Y, Float64)

    w = rand(m)

    test_pairwise(WeightedSqEuclidean(w), X, Y, Float64)
    test_pairwise(WeightedEuclidean(w), X, Y, Float64)
end

function test_scalar_pairwise(dist, x, y, T)
    @testset "Scalar pairwise test for $(typeof(dist))" begin
        rxy = dist.(x, permutedims(y))
        rxx = dist.(x, permutedims(x))
        # As earlier, we have small rounding errors in accumulations
        @test pairwise(dist, x, y) ≈ rxy
        @test pairwise(dist, x) ≈ rxx
        @test pairwise(dist, permutedims(x), permutedims(y), dims=2) ≈ rxy
        @test pairwise(dist, permutedims(x), dims=2) ≈ rxx
        @test_throws DimensionMismatch pairwise(dist, permutedims(x), permutedims(y), dims=1)

        # In-place computations
        rxy2 = similar(rxy)
        fill!(rxy2, zero(eltype(rxy2)))
        @test @test_deprecated(pairwise!(rxy2, dist, x, y)) ≈ rxy
        @test rxy2 ≈ rxy
        fill!(rxy2, zero(eltype(rxy2)))
        @test pairwise!(dist, rxy2, x, y) ≈ rxy
        @test rxy2 ≈ rxy

        rxx2 = similar(rxx)
        fill!(rxx2, zero(eltype(rxx2)))
        @test @test_deprecated(pairwise!(rxx2, dist, x)) ≈ rxx
        @test rxx2 ≈ rxx
        fill!(rxx2, zero(eltype(rxx2)))
        @test pairwise!(dist, rxx2, x) ≈ rxx
        @test rxx2 ≈ rxx

        fill!(rxy2, zero(eltype(rxy2)))
        @test @test_deprecated(pairwise!(rxy2, dist, permutedims(x), permutedims(y); dims=2)) ≈ rxy
        @test rxy2 ≈ rxy
        fill!(rxy2, zero(eltype(rxy2)))
        @test pairwise!(dist, rxy2, permutedims(x), permutedims(y); dims=2) ≈ rxy
        @test rxy2 ≈ rxy

        fill!(rxx2, zero(eltype(rxx2)))
        @test @test_deprecated(pairwise!(rxx2, dist, permutedims(x); dims=2)) ≈ rxx
        @test rxx2 ≈ rxx
        fill!(rxx2, zero(eltype(rxx2)))
        @test pairwise!(dist, rxx2, permutedims(x); dims=2) ≈ rxx
        @test rxx2 ≈ rxx
    end
end

@testset "scalar pairwise metrics on $T" for T in (Float64, F64)
    m = 5
    n = 8
    nx = 6
    ny = 8
    x = rand(T, nx)
    y = rand(T, ny)
    a = rand(1:3, nx)
    b = rand(1:3, ny)
    test_scalar_pairwise(SqEuclidean(), x, y, T)
    test_scalar_pairwise(sqeuclidean, x, y, T)
    test_scalar_pairwise(Euclidean(), x, y, T)
    test_scalar_pairwise(euclidean, x, y, T)
    test_scalar_pairwise(Cityblock(), x, y, T)
    test_scalar_pairwise(cityblock, x, y, T)
    test_scalar_pairwise(TotalVariation(), x, y, T)
    test_scalar_pairwise(totalvariation, x, y, T)
    test_scalar_pairwise(Chebyshev(), x, y, T)
    test_scalar_pairwise(chebyshev, x, y, T)
    test_scalar_pairwise(Minkowski(2.5), x, y, T)
    test_scalar_pairwise(Hamming(), a, b, T)
    test_scalar_pairwise(hamming, a, b, T)
    test_scalar_pairwise(CosineDist(), x, y, T)
    test_scalar_pairwise(cosine_dist, x, y, T)
    test_scalar_pairwise(CosineDist(), a, b, T)
    test_scalar_pairwise(cosine_dist, a, b, T)
    test_scalar_pairwise(ChiSqDist(), x, y, T)
    test_scalar_pairwise(chisq_dist, x, y, T)
    test_scalar_pairwise(KLDivergence(), x, y, T)
    test_scalar_pairwise(kl_divergence, x, y, T)
    test_scalar_pairwise(JSDivergence(), x, y, T)
    test_scalar_pairwise(js_divergence, x, y, T)
    test_scalar_pairwise(BrayCurtis(), x, y, T)
    test_scalar_pairwise(braycurtis, x, y, T)
    w = rand(1, 1)
    test_scalar_pairwise(WeightedSqEuclidean(w), x, y, T)
    test_scalar_pairwise(WeightedEuclidean(w), x, y, T)
    test_scalar_pairwise(WeightedCityblock(w), x, y, T)
    test_scalar_pairwise(WeightedMinkowski(w, 2.5), x, y, T)
    test_scalar_pairwise(WeightedHamming(w), a, b, T)
    test_scalar_pairwise(PeriodicEuclidean(w), x, y, T)
end

@testset "Euclidean precision" begin
    x = [0.1 0.1; 0.3 0.3; -0.1 -0.1]
    for X in (x, complex(x))
        @test iszero(pairwise(Euclidean(1e-12), X, X, dims=2))
        @test iszero(pairwise(Euclidean(1e-12), X, dims=2))
        @test iszero(pairwise(SqEuclidean(1e-12), X, X, dims=2))
        @test iszero(pairwise(SqEuclidean(1e-12), X, dims=2))
    end
end

@testset "non-negativity" begin
    X = [0.3 0.3 + eps()]

    @test all(x -> x >= 0, pairwise(SqEuclidean(), X; dims = 2))
    @test all(x -> x >= 0, pairwise(sqeuclidean, X; dims = 2))
    @test all(x -> x >= 0, pairwise(SqEuclidean(), X, X; dims = 2))
    @test all(x -> x >= 0, pairwise(sqeuclidean, X, X; dims = 2))
    @test all(x -> x >= 0, pairwise(Euclidean(), X; dims = 2))
    @test all(x -> x >= 0, pairwise(euclidean, X; dims = 2))
    @test all(x -> x >= 0, pairwise(Euclidean(), X, X; dims = 2))
    @test all(x -> x >= 0, pairwise(euclidean, X, X; dims = 2))
    @test all(x -> x >= 0, pairwise(WeightedSqEuclidean([1.0]), X; dims = 2))
    @test all(x -> x >= 0, pairwise(WeightedSqEuclidean([1.0]), X, X; dims = 2))
    @test all(x -> x >= 0, pairwise(SqMahalanobis(ones(1, 1)), X; dims = 2))
    @test all(x -> x >= 0, pairwise(SqMahalanobis(ones(1, 1)), X, X; dims = 2))
end

@testset "Bregman Divergence" begin
    # Some basic tests.
    @test_throws ArgumentError bregman(x -> x, x -> 2*x, [1, 2, 3], [1, 2, 3])
    # Test if Bregman() correctly implements the gkl divergence between two random vectors.
    F(p) = LinearAlgebra.dot(p, log.(p));
    ∇F(p) = map(x -> log(x) + 1, p)
    testDist = Bregman(F, ∇F)
    p = rand(4)
    q = rand(4)
    p = p/sum(p)
    q = q/sum(q)
    for (p, q) in ((p, q),
                   (Iterators.take(p, 4), Iterators.take(q, 4)),
                   ((p[i] for i in 1:4), (q[i] for i in 1:4)),
                   )
        @test testDist(p, q) ≈ gkl_divergence(p, q)
        # Test if Bregman() correctly implements the squared euclidean dist. between them.
        @test bregman(x -> norm(x)^2, x -> 2 .* x, p, q) ≈ sqeuclidean(p, q)
    end
    # Test if Bregman() correctly implements the IS distance.
    G(p) = -1 * sum(log.(p))
    ∇G(p) = map(x -> -1 * x^(-1), p)
    function ISdist(p::AbstractVector, q::AbstractVector)
        return sum([p[i]/q[i] - log(p[i]/q[i]) - 1 for i in eachindex(p, q)])
    end
    @test bregman(G, ∇G, p, q) ≈ ISdist(p, q)
end

@testset "Unitful data" begin
    using Distances, Unitful.DefaultSymbols, Test, LinearAlgebra
    x = [1m, 2m, 3m]; y = [2m, 3m, 4m]; w = [1, 1, 1]; p = [2m, 2m, 2m]
    @test @inferred sqeuclidean(x, y) == 3m^2
    @test @inferred euclidean(x, y) == sqrt(3)m
    @test @inferred cityblock(x, y) == 3m
    @test @inferred totalvariation(x, y) == 1.5m
    @test @inferred chebyshev(x, y) == 1m
    @test @inferred minkowski(x, y, 2) == sqrt(3)m
    @test @inferred jaccard(x, y) == 1 - sum(min.(x, y)) / sum(max.(x, y))
    @test @inferred braycurtis(x, y) == sum(abs.(x .- y)) / sum(abs.(x .+ y))
    @test @inferred cosine_dist(x, y) == 1 - dot(x, y) / (norm(x) * norm(y))
    @test @inferred corr_dist(x, y) == cosine_dist(x .- mean(x), y .- mean(y))
    @test @inferred chisq_dist(x, y) == sum((x .- y).^2 ./ (x .+ y))
    @test @inferred spannorm_dist(x, y) == 0m
    @test @inferred hellinger(x, y) == sqrt(1 - sum(sqrt.(x .* y) / sqrt(sum(x) * sum(y))))
    @test @inferred meanad(x, y) == 1m
    @test @inferred msd(x, y) == 1m^2
    @test @inferred rmsd(x, y) == 1m
    @test @inferred nrmsd(x, y) == rmsd(x, y) / (maximum(x) - minimum(x))
    @test @inferred weuclidean(x, y, w) == euclidean(x, y)
    @test @inferred wsqeuclidean(x, y, w) == sqeuclidean(x, y)
    @test @inferred wcityblock(x, y, w) == cityblock(x, y)
    @test @inferred wminkowski(x, y, w, 2) == euclidean(x, y)
    @test @inferred whamming(x, y, w) == hamming(x, y)
    @test @inferred peuclidean(x, y, p) == sqrt(3)m

    X = [x y]; Y = [y x]
    # check specialized pairwise implementations
    @test pairwise(Euclidean(), X, dims=2)[1,1] == 0m
    @test pairwise(Euclidean(), X, dims=2)[1,2] == sqrt(3)m
    @test pairwise(SqEuclidean(), X, dims=2)[1,1] == 0m^2
    @test pairwise(SqEuclidean(), X, dims=2)[1,2] == 3m^2
    @test pairwise(WeightedEuclidean(w), X, dims=2)[1,1] == 0m
    @test pairwise(WeightedEuclidean(w), X, dims=2)[1,2] == sqrt(3)m
    @test pairwise(WeightedSqEuclidean(w), X, dims=2)[1,1] == 0m^2
    @test pairwise(WeightedSqEuclidean(w), X, dims=2)[1,2] == 3m^2
    @test pairwise(Euclidean(), X, Y, dims=2)[1,1] == sqrt(3)m
    @test pairwise(Euclidean(), X, Y, dims=2)[1,2] == 0m
    @test pairwise(SqEuclidean(), X, Y, dims=2)[1,1] == 3m^2
    @test pairwise(SqEuclidean(), X, Y, dims=2)[1,2] == 0m^2
    @test pairwise(WeightedEuclidean(w), X, Y, dims=2)[1,1] == sqrt(3)m
    @test pairwise(WeightedEuclidean(w), X, Y, dims=2)[1,2] == 0m
    @test pairwise(WeightedSqEuclidean(w), X, Y, dims=2)[1,1] == 3m^2
    @test pairwise(WeightedSqEuclidean(w), X, Y, dims=2)[1,2] == 0m^2
    @test pairwise(CosineDist(), X, dims=2)[1,1] == 0
    @test pairwise(CosineDist(), X, dims=2)[1,2] == 1 - dot(x, y) / (norm(x) * norm(y))
    @test pairwise(CorrDist(), X, dims=2)[1,1] == 0
    @test pairwise(CorrDist(), X, dims=2)[1,2] == cosine_dist(x .- mean(x), y .- mean(y))
    # check generic pairwise implementation for one metric
    @test pairwise(PeriodicEuclidean(p), X, dims=2)[1,1] == 0m
    @test pairwise(PeriodicEuclidean(p), X, dims=2)[1,2] == sqrt(3)m
    @test pairwise(PeriodicEuclidean(p), X, Y, dims=2)[1,1] == sqrt(3)m
    @test pairwise(PeriodicEuclidean(p), X, Y, dims=2)[1,2] == 0m
end

@testset "SparseVector, nnz(a) != nnz(b)" begin
    for (n, densa, densb) in ((100, .1, .8), (200, .8, .1))
        a = sprand(n, densa)
        b = sprand(n, densb)
        for d in (bhattacharyya, euclidean, sqeuclidean, jaccard, cityblock, totalvariation,
                  chebyshev, braycurtis, hamming)
            @test d(a, b) ≈ d(Vector(a), Vector(b))
        end
    end
end

#=
@testset "zero allocation colwise!" begin
    d = Euclidean()
    a = rand(2, 41)
    b = rand(2, 41)
    z = zeros(41)
    colwise!(d, z, a, b)
    # This fails when bounds checking is enforced
    bounds = Base.JLOptions().check_bounds
    if bounds == 0
        @test (@allocated colwise!(d, z, a, b)) == 0
    else
        @test_broken (@allocated colwise!(d, z, a, b)) == 0
    end
end
=#

module DistancesSparseArraysExt

using Distances
import Distances: _evaluate
using Distances: UnionMetrics, result_type, eval_start, eval_op, eval_reduce, eval_end
using SparseArrays: SparseVectorUnion, nonzeroinds, nonzeros, nnz

eval_op_a(d, ai, b) = eval_op(d, ai, zero(eltype(b)))
eval_op_b(d, bi, a) = eval_op(d, zero(eltype(a)), bi)

# It is assumed that eval_reduce(d, s, eval_op(d, zero(eltype(a)), zero(eltype(b)))) == s
# This justifies ignoring all terms where both inputs are zero.
Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a::SparseVectorUnion, b::SparseVectorUnion, ::Nothing)
    @boundscheck if length(a) != length(b)
        throw(DimensionMismatch("first array has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end
    if length(a) == 0
        return zero(result_type(d, a, b))
    end
    anzind = nonzeroinds(a)
    bnzind = nonzeroinds(b)
    anzval = nonzeros(a)
    bnzval = nonzeros(b)
    ma = nnz(a)
    mb = nnz(b)
    ia = 1; ib = 1
    s = eval_start(d, a, b)
    @inbounds while ia <= ma && ib <= mb
        ja = anzind[ia]
        jb = bnzind[ib]
        if ja == jb
            v = eval_op(d, anzval[ia], bnzval[ib])
            ia += 1; ib += 1
        elseif ja < jb
            v = eval_op_a(d, anzval[ia], b)
            ia += 1
        else
            v = eval_op_b(d, bnzval[ib], a)
            ib += 1
        end
        s = eval_reduce(d, s, v)
    end
    @inbounds while ia <= ma
        v = eval_op_a(d, anzval[ia], b)
        s = eval_reduce(d, s, v)
        ia += 1
    end
    @inbounds while ib <= mb
        v = eval_op_b(d, bnzval[ib], a)
        s = eval_reduce(d, s, v)
        ib += 1
    end
    return eval_end(d, s)
end

@inline function _bhattacharyya_coeff(a::SparseVectorUnion, b::SparseVectorUnion)
    anzind = nonzeroinds(a)
    bnzind = nonzeroinds(b)
    anzval = nonzeros(a)
    bnzval = nonzeros(b)
    ma = nnz(a)
    mb = nnz(b)

    ia = 1; ib = 1
    s = zero(typeof(sqrt(oneunit(eltype(a))*oneunit(eltype(b)))))
    @inbounds while ia <= ma && ib <= mb
        ja = anzind[ia]
        jb = bnzind[ib]
        if ja == jb
            s += sqrt(anzval[ia] * bnzval[ib])
            ia += 1; ib += 1
        elseif ja < jb
            ia += 1
        else
            ib += 1
        end
    end
    # efficient method for sum for SparseVectorView is missing
    return s, sum(anzval), sum(bnzval)
end

end # module DistancesSparseArraysExt

module DistancesChainRulesCoreExt

using Distances

import ChainRulesCore

const CRC = ChainRulesCore

## SqEuclidean

function CRC.rrule(
    ::CRC.RuleConfig{>:CRC.HasReverseMode},
    dist::SqEuclidean,
    x::AbstractVector{<:Real},
    y::AbstractVector{<:Real}
)
    Ω = dist(x, y)

    function SqEuclidean_pullback(ΔΩ)
        x̄ = (2 * CRC.unthunk(ΔΩ)) .* (x .- y)
        return CRC.NoTangent(), x̄, -x̄
    end

    return Ω, SqEuclidean_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(colwise), dist::SqEuclidean, X::AbstractMatrix{<:Real}, Y::AbstractMatrix{<:Real})
    Ω = colwise(dist, X, Y)

    function colwise_SqEuclidean_pullback(ΔΩ)
        X̄ = 2 .* CRC.unthunk(ΔΩ)' .* (X .- Y)
        return CRC.NoTangent(), CRC.NoTangent(), X̄, -X̄
    end

    return Ω, colwise_SqEuclidean_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(pairwise), dist::SqEuclidean, X::AbstractMatrix{<:Real}; dims::Union{Nothing,Integer}=nothing)
    dims = Distances.deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    Ω = pairwise(dist, X; dims=dims)

    function pairwise_SqEuclidean_X_pullback(ΔΩ)
        Δ = CRC.unthunk(ΔΩ)
        A = Δ .+ transpose(Δ)
        X̄ = if dims == 1
            2 .* (sum(A; dims=2) .* X .- A * X)
        else
            2 .* (X .* sum(A; dims=1) .- X * A)
        end
        return CRC.NoTangent(), CRC.NoTangent(), X̄
    end

    return Ω, pairwise_SqEuclidean_X_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(pairwise), dist::SqEuclidean, X::AbstractMatrix{<:Real}, Y::AbstractMatrix{<:Real}; dims::Union{Nothing,Integer}=nothing)
    dims = Distances.deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    Ω = pairwise(dist, X, Y; dims=dims)

    function pairwise_SqEuclidean_X_Y_pullback(ΔΩ)
        Δ = CRC.unthunk(ΔΩ)
        Δt = transpose(Δ)
        X̄ = if dims == 1
            2 .* (sum(Δ; dims=2) .* X .- Δ * Y)
        else
            2 .* (X .* sum(Δt; dims=1) .- Y * Δt)
        end
        Ȳ = if dims == 1
            2 .* (sum(Δt; dims=2) .* Y .- Δt * X)
        else
            2 .* (Y .* sum(Δ; dims=1) .- X * Δ)
        end
        return CRC.NoTangent(), CRC.NoTangent(), X̄, Ȳ
    end

    return Ω, pairwise_SqEuclidean_X_Y_pullback
end

## Euclidean

_normalize(x::Real, nrm::Real) = iszero(nrm) && !isnan(x) ? one(x / nrm) : x / nrm

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, dist::Euclidean, x::AbstractVector{<:Real}, y::AbstractVector{<:Real})
    Ω = dist(x, y)

    function Euclidean_pullback(ΔΩ)
        x̄ = _normalize(CRC.unthunk(ΔΩ), Ω) .* (x .- y)
        return CRC.NoTangent(), x̄, -x̄
    end

    return Ω, Euclidean_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(colwise), dist::Euclidean, X::AbstractMatrix{<:Real}, Y::AbstractMatrix{<:Real})
    Ω = colwise(dist, X, Y)

    function colwise_Euclidean_pullback(ΔΩ)
        X̄ = _normalize.(CRC.unthunk(ΔΩ)', Ω') .* (X .- Y)
        return CRC.NoTangent(), CRC.NoTangent(), X̄, -X̄
    end

    return Ω, colwise_Euclidean_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(pairwise), dist::Euclidean, X::AbstractMatrix{<:Real}; dims::Union{Nothing,Integer}=nothing)
    dims = Distances.deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    Ω = pairwise(dist, X; dims=dims)

    function pairwise_Euclidean_X_pullback(ΔΩ)
        Δ = CRC.unthunk(ΔΩ)
        A = _normalize.(Δ .+ transpose(Δ), Ω)
        X̄ = if dims == 1
            sum(A; dims=2) .* X .- A * X
        else
            X .* sum(A; dims=1) .- X * A
        end
        return CRC.NoTangent(), CRC.NoTangent(), X̄
    end

    return Ω, pairwise_Euclidean_X_pullback
end

function CRC.rrule(::CRC.RuleConfig{>:CRC.HasReverseMode}, ::typeof(pairwise), dist::Euclidean, X::AbstractMatrix{<:Real}, Y::AbstractMatrix{<:Real}; dims::Union{Nothing,Integer}=nothing)
    dims = Distances.deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    Ω = pairwise(dist, X, Y; dims=dims)

    function pairwise_Euclidean_X_Y_pullback(ΔΩ)
        Δ = _normalize.(CRC.unthunk(ΔΩ), Ω)
        Δt = transpose(Δ)
        X̄ = if dims == 1
            sum(Δ; dims=2) .* X .- Δ * Y
        else
            X .* sum(Δt; dims=1) .- Y * Δt
        end
        Ȳ = if dims == 1
            sum(Δt; dims=2) .* Y .- Δt * X
        else
            Y .* sum(Δ; dims=1) .- X * Δ
        end
        return CRC.NoTangent(), CRC.NoTangent(), X̄, Ȳ
    end

    return Ω, pairwise_Euclidean_X_Y_pullback
end

end # module

module Distances

using LinearAlgebra
using Statistics: mean
import StatsAPI: pairwise, pairwise!

export
    # generic types/functions
    PreMetric,
    SemiMetric,
    Metric,
    MinkowskiMetric,

    # generic functions
    result_type,
    colwise,
    pairwise,
    colwise!,
    pairwise!,
    evaluate,

    # distance classes
    Euclidean,
    SqEuclidean,
    PeriodicEuclidean,
    Cityblock,
    TotalVariation,
    Chebyshev,
    Minkowski,
    Jaccard,
    BrayCurtis,
    RogersTanimoto,

    Hamming,
    CosineDist,
    CorrDist,
    ChiSqDist,
    KLDivergence,
    GenKLDivergence,
    JSDivergence,
    RenyiDivergence,
    SpanNormDist,

    WeightedEuclidean,
    WeightedSqEuclidean,
    WeightedCityblock,
    WeightedMinkowski,
    WeightedHamming,
    SqMahalanobis,
    Mahalanobis,
    BhattacharyyaDist,
    HellingerDist,

    Haversine,
    SphericalAngle,

    MeanAbsDeviation,
    MeanSqDeviation,
    RMSDeviation,
    NormRMSDeviation,
    Bregman,

    # convenient functions
    euclidean,
    sqeuclidean,
    peuclidean,
    cityblock,
    totalvariation,
    jaccard,
    braycurtis,
    rogerstanimoto,
    chebyshev,
    minkowski,

    hamming,
    cosine_dist,
    corr_dist,
    chisq_dist,
    kl_divergence,
    gkl_divergence,
    js_divergence,
    renyi_divergence,
    spannorm_dist,

    weuclidean,
    wsqeuclidean,
    wcityblock,
    wminkowski,
    whamming,
    sqmahalanobis,
    mahalanobis,
    bhattacharyya,
    hellinger,
    bregman,

    haversine,
    spherical_angle,

    meanad,
    msd,
    rmsd,
    nrmsd

if VERSION < v"1.2-"
    import Base: has_offset_axes
    require_one_based_indexing(A...) =
        !has_offset_axes(A...) ||
            throw(ArgumentError("offset arrays are not supported but got an array with index other than 1"))
else
    import Base: require_one_based_indexing
end

include("common.jl")
include("generic.jl")
include("metrics.jl")
include("haversine.jl")
include("mahalanobis.jl")
include("bhattacharyya.jl")
include("bregman.jl")

include("deprecated.jl")

@static if !isdefined(Base, :get_extension)
    include("../ext/DistancesSparseArraysExt.jl")
end

end # module end

# Ordinary metrics

###########################################################
#
#   Abstract metric types
#
###########################################################

abstract type UnionPreMetric <: PreMetric end

abstract type UnionSemiMetric <: SemiMetric end

abstract type UnionMetric <: Metric end

###########################################################
#
#   Metric types
#
###########################################################

struct Euclidean <: UnionMetric
    thresh::Float64
end

"""
    Euclidean([thresh])

Create a euclidean metric.

When computing distances among large numbers of points, it can be much
more efficient to exploit the formula

    (x-y)^2 = x^2 - 2xy + y^2

However, this can introduce roundoff error. `thresh` (which defaults
to 0) specifies the relative square-distance tolerance on `2xy`
compared to `x^2 + y^2` to force recalculation of the distance using
the more precise direct (elementwise-subtraction) formula.

# Example:
```julia
julia> x = reshape([0.1, 0.3, -0.1], 3, 1);

julia> pairwise(Euclidean(), x, x)
1×1 Array{Float64,2}:
 7.45058e-9

julia> pairwise(Euclidean(1e-12), x, x)
1×1 Array{Float64,2}:
 0.0
```
"""
Euclidean() = Euclidean(0)

struct WeightedEuclidean{W} <: UnionMetric
    weights::W
end

"""
    PeriodicEuclidean(L)

Create a Euclidean metric on a rectangular periodic domain (i.e., a torus or
a cylinder). Periods per dimension are contained in the vector `L`:
```math
\\sqrt{\\sum_i(\\min\\mod(|x_i - y_i|, p), p - \\mod(|x_i - y_i|, p))^2}.
```
For dimensions without periodicity put `Inf` in the respective component.

# Example
```jldoctest
julia> x, y, L = [0.0, 0.0], [0.75, 0.0], [0.5, Inf];

julia> evaluate(PeriodicEuclidean(L), x, y)
0.25
```
"""
struct PeriodicEuclidean{W} <: UnionMetric
    periods::W
end

struct SqEuclidean <: UnionSemiMetric
    thresh::Float64
end

"""
    SqEuclidean([thresh])

Create a squared-euclidean semi-metric. For the meaning of `thresh`,
see [`Euclidean`](@ref).
"""
SqEuclidean() = SqEuclidean(0)

struct WeightedSqEuclidean{W} <: UnionSemiMetric
    weights::W
end

struct Chebyshev <: UnionMetric end

struct Cityblock <: UnionMetric end
struct WeightedCityblock{W} <: UnionMetric
    weights::W
end

struct TotalVariation <: UnionMetric end
struct Jaccard <: UnionMetric end
struct RogersTanimoto <: UnionMetric end

struct Minkowski{T <: Real} <: UnionMetric
    p::T
end
struct WeightedMinkowski{W,T <: Real} <: UnionMetric
    weights::W
    p::T
end

struct Hamming <: UnionMetric end
struct WeightedHamming{W} <: UnionMetric
    weights::W
end

struct CosineDist <: UnionSemiMetric end
# CorrDist is excluded from `UnionMetrics`
struct CorrDist <: SemiMetric end
struct BrayCurtis <: UnionSemiMetric end

struct ChiSqDist <: UnionSemiMetric end
struct KLDivergence <: UnionPreMetric end
struct GenKLDivergence <: UnionPreMetric end

"""
    RenyiDivergence(α::Real)
    renyi_divergence(P, Q, α::Real)

Create a Rényi premetric of order α.

Rényi defined a spectrum of divergence measures generalising the
Kullback–Leibler divergence (see `KLDivergence`). The divergence is
not a semimetric as it is not symmetric. It is parameterised by a
parameter α, and is equal to Kullback–Leibler divergence at α = 1:

At α = 0, ``R_0(P | Q) = -log(sum_{i: p_i > 0}(q_i))``

At α = 1, ``R_1(P | Q) = sum_{i: p_i > 0}(p_i log(p_i / q_i))``

At α = ∞, ``R_∞(P | Q) = log(sup_{i: p_i > 0}(p_i / q_i))``

Otherwise ``R_α(P | Q) = log(sum_{i: p_i > 0}((p_i ^ α) / (q_i ^ (α - 1))) / (α - 1)``

# Example:
```jldoctest
julia> x = reshape([0.1, 0.3, 0.4, 0.2], 2, 2);

julia> pairwise(RenyiDivergence(0), x, x)
2×2 Array{Float64,2}:
 0.0  0.0
 0.0  0.0

julia> pairwise(Euclidean(2), x, x)
2×2 Array{Float64,2}:
 0.0       0.577315
 0.655407  0.0
```
"""
struct RenyiDivergence{T <: Real} <: UnionPreMetric
    p::T # order of power mean (order of divergence - 1)
    is_normal::Bool
    is_zero::Bool
    is_one::Bool
    is_inf::Bool

    function RenyiDivergence{T}(q) where {T}
        # There are four different cases:
        #   simpler to separate them out now, not over and over in eval_op()
        is_zero = q ≈ zero(T)
        is_one = q ≈ one(T)
        is_inf = isinf(q)

        # Only positive Rényi divergences are defined
        !is_zero && q < zero(T) && throw(ArgumentError("Order of Rényi divergence not legal, $(q) < 0."))

        new{T}(q - 1, !(is_zero || is_one || is_inf), is_zero, is_one, is_inf)
    end
end
RenyiDivergence(q::T) where {T} = RenyiDivergence{T}(q)

struct JSDivergence <: UnionSemiMetric end

struct SpanNormDist <: UnionSemiMetric end

# Deviations are handled separately from the other distances/divergences and
# are excluded from `UnionMetrics`
struct MeanAbsDeviation <: Metric end
struct MeanSqDeviation <: SemiMetric end
struct RMSDeviation <: Metric end
struct NormRMSDeviation <: PreMetric end

# Union types
const metrics = (Euclidean,SqEuclidean,PeriodicEuclidean,Chebyshev,Cityblock,TotalVariation,Minkowski,Hamming,Jaccard,RogersTanimoto,CosineDist,ChiSqDist,KLDivergence,RenyiDivergence,BrayCurtis,JSDivergence,SpanNormDist,GenKLDivergence)
const weightedmetrics = (WeightedEuclidean,WeightedSqEuclidean,WeightedCityblock,WeightedMinkowski,WeightedHamming)
const UnionMetrics = Union{UnionPreMetric,UnionSemiMetric,UnionMetric}

###########################################################
#
#  Implementations
#
###########################################################

parameters(::UnionPreMetric) = nothing
parameters(::UnionSemiMetric) = nothing
parameters(::UnionMetric) = nothing
parameters(d::PeriodicEuclidean) = d.periods
for dist in weightedmetrics
    @eval parameters(d::$dist) = d.weights
end

result_type(dist::UnionMetrics, ::Type{Ta}, ::Type{Tb}) where {Ta,Tb} =
    result_type(dist, _eltype(Ta), _eltype(Tb), parameters(dist))
result_type(dist::UnionMetrics, ::Type{Ta}, ::Type{Tb}, ::Nothing) where {Ta,Tb} =
    typeof(_evaluate(dist, oneunit(Ta), oneunit(Tb)))
result_type(dist::UnionMetrics, ::Type{Ta}, ::Type{Tb}, p) where {Ta,Tb} =
    typeof(_evaluate(dist, oneunit(Ta), oneunit(Tb), oneunit(_eltype(p))))

Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a, b)
    _evaluate(d, a, b, parameters(d))
end

# breaks the implementation into eval_start, eval_op, eval_reduce and eval_end

Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a, b, ::Nothing)
    @boundscheck if length(a) != length(b)
        throw(DimensionMismatch("first collection has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end
    if length(a) == 0
        return zero(result_type(d, a, b))
    end
    s = eval_start(d, a, b)
    @inbounds for (ai, bi) in zip(a, b)
        s = eval_reduce(d, s, eval_op(d, ai, bi))
    end
    return eval_end(d, s)
end
Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a::AbstractArray, b::AbstractArray, ::Nothing)
    @boundscheck if length(a) != length(b)
        throw(DimensionMismatch("first array has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end
    if length(a) == 0
        return zero(result_type(d, a, b))
    end
    @inbounds begin
        s = eval_start(d, a, b)
        if (IndexStyle(a, b) === IndexLinear() && eachindex(a) == eachindex(b)) || axes(a) == axes(b)
            @simd for I in eachindex(a, b)
                ai = a[I]
                bi = b[I]
                s = eval_reduce(d, s, eval_op(d, ai, bi))
            end
        else
            for (ai, bi) in zip(a, b)
                s = eval_reduce(d, s, eval_op(d, ai, bi))
            end
        end
        return eval_end(d, s)
    end
end

Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a, b, p)
    @boundscheck if length(a) != length(b)
        throw(DimensionMismatch("first collection has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end
    @boundscheck if length(a) != length(p)
        throw(DimensionMismatch("data collections have length $(length(a)) but parameters have length $(length(p))."))
    end
    if length(a) == 0
        return zero(result_type(d, a, b))
    end
    s = eval_start(d, a, b)
    @inbounds for (ai, bi, pi) in zip(a, b, p)
        s = eval_reduce(d, s, eval_op(d, ai, bi, pi))
    end
    return eval_end(d, s)
end
Base.@propagate_inbounds function _evaluate(d::UnionMetrics, a::AbstractArray, b::AbstractArray, p::AbstractArray)
    @boundscheck if length(a) != length(b)
        throw(DimensionMismatch("first array has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end
    @boundscheck if length(a) != length(p)
        throw(DimensionMismatch("arrays have length $(length(a)) but parameters have length $(length(p))."))
    end
    if length(a) == 0
        return zero(result_type(d, a, b))
    end
    @inbounds begin
        s = eval_start(d, a, b)
        if (IndexStyle(a, b, p) === IndexLinear() && eachindex(a) == eachindex(b) == eachindex(p)) ||
                axes(a) == axes(b) == axes(p)
            @simd for I in eachindex(a, b, p)
                ai = a[I]
                bi = b[I]
                pi = p[I]
                s = eval_reduce(d, s, eval_op(d, ai, bi, pi))
            end
        else
            for (ai, bi, pi) in zip(a, b, p)
                s = eval_reduce(d, s, eval_op(d, ai, bi, pi))
            end
        end
        return eval_end(d, s)
    end
end

_evaluate(dist::UnionMetrics, a::Number, b::Number, ::Nothing) = eval_end(dist, eval_op(dist, a, b))
function _evaluate(dist::UnionMetrics, a::Number, b::Number, p)
    length(p) != 1 && throw(DimensionMismatch("inputs are scalars but parameters have length $(length(p))."))
    eval_end(dist, eval_op(dist, a, b, first(p)))
end

eval_start(d::UnionMetrics, a, b) = _eval_start(d, _eltype(a), _eltype(b))
_eval_start(d::UnionMetrics, ::Type{Ta}, ::Type{Tb}) where {Ta,Tb} =
    _eval_start(d, Ta, Tb, parameters(d))
_eval_start(d::UnionMetrics, ::Type{Ta}, ::Type{Tb}, ::Nothing) where {Ta,Tb} =
    zero(typeof(eval_op(d, oneunit(Ta), oneunit(Tb))))
_eval_start(d::UnionMetrics, ::Type{Ta}, ::Type{Tb}, p) where {Ta,Tb} =
    zero(typeof(eval_op(d, oneunit(Ta), oneunit(Tb), oneunit(_eltype(p)))))
eval_reduce(::UnionMetrics, s1, s2) = s1 + s2
eval_end(::UnionMetrics, s) = s

for M in (metrics..., weightedmetrics...)
    @eval @inline (dist::$M)(a, b) = _evaluate(dist, a, b, parameters(dist))
end

# Euclidean
@inline eval_op(::Euclidean, ai, bi) = abs2(ai - bi)
eval_end(::Euclidean, s) = sqrt(s)
const euclidean = Euclidean()

# Weighted Euclidean
@inline eval_op(::WeightedEuclidean, ai, bi, wi) = abs2(ai - bi) * wi
eval_end(::WeightedEuclidean, s) = sqrt(s)
weuclidean(a, b, w) = WeightedEuclidean(w)(a, b)

# PeriodicEuclidean
@inline function eval_op(::PeriodicEuclidean, ai, bi, p)
    s1 = abs(ai - bi)
    s2 = mod(s1, p)
    s3 = min(s2, p - s2)
    abs2(s3)
end
eval_end(::PeriodicEuclidean, s) = sqrt(s)
peuclidean(a, b, p) = PeriodicEuclidean(p)(a, b)

# SqEuclidean
@inline eval_op(::SqEuclidean, ai, bi) = abs2(ai - bi)
const sqeuclidean = SqEuclidean()

# Weighted Squared Euclidean
@inline eval_op(::WeightedSqEuclidean, ai, bi, wi) = abs2(ai - bi) * wi
wsqeuclidean(a, b, w) = WeightedSqEuclidean(w)(a, b)

# Cityblock
@inline eval_op(::Cityblock, ai, bi) = abs(ai - bi)
const cityblock = Cityblock()

# Weighted City Block
@inline eval_op(::WeightedCityblock, ai, bi, wi) = abs((ai - bi) * wi)
wcityblock(a, b, w) = WeightedCityblock(w)(a, b)

# Total variation
@inline eval_op(::TotalVariation, ai, bi) = abs(ai - bi)
eval_end(::TotalVariation, s) = s / 2
const totalvariation = TotalVariation()

# Chebyshev
@inline eval_op(::Chebyshev, ai, bi) = abs(ai - bi)
@inline eval_reduce(::Chebyshev, s1, s2) = max(s1, s2)
# if only NaN, will output NaN
Base.@propagate_inbounds eval_start(::Chebyshev, a, b) = abs(first(a) - first(b))
const chebyshev = Chebyshev()

# Minkowski
@inline eval_op(dist::Minkowski, ai, bi) = abs(ai - bi)^dist.p
@inline eval_end(dist::Minkowski, s) = s^(1 / dist.p)
minkowski(a, b, p::Real) = Minkowski(p)(a, b)

# Weighted Minkowski
@inline eval_op(dist::WeightedMinkowski, ai, bi, wi) = abs(ai - bi)^dist.p * wi
@inline eval_end(dist::WeightedMinkowski, s) = s^(1 / dist.p)
wminkowski(a, b, w, p::Real) = WeightedMinkowski(w, p)(a, b)

# Hamming
result_type(::Hamming, ::Type, ::Type) = Int # fallback for Hamming
eval_start(d::Hamming, a, b) = 0
@inline eval_op(::Hamming, ai, bi) = ai != bi ? 1 : 0
const hamming = Hamming()

# WeightedHamming
@inline eval_op(::WeightedHamming, ai, bi, wi) = ai != bi ? wi : zero(eltype(wi))
whamming(a, b, w) = WeightedHamming(w)(a, b)

# Cosine dist
@inline eval_start(dist::CosineDist, a, b) =
    zero.(typeof.(eval_op(dist, oneunit(_eltype(a)), oneunit(_eltype(b)))))
@inline eval_op(::CosineDist, ai, bi) = ai * bi, ai * ai, bi * bi
@inline function eval_reduce(::CosineDist, s1, s2)
    a1, b1, c1 = s1
    a2, b2, c2 = s2
    return a1 + a2, b1 + b2, c1 + c2
end
function eval_end(::CosineDist, s)
    ab, a2, b2 = s
    max(1 - ab / (sqrt(a2) * sqrt(b2)), 0)
end
const cosine_dist = CosineDist()

# CorrDist
_centralize(x) = x .- mean(x)
(::CorrDist)(a, b) = CosineDist()(_centralize(a), _centralize(b))
(::CorrDist)(a::Number, b::Number) = CosineDist()(zero(mean(a)), zero(mean(b)))
const corr_dist = CorrDist()

# ChiSqDist
@inline eval_op(::ChiSqDist, ai, bi) = (d = abs2(ai - bi) / (ai + bi); ifelse(ai != bi, d, zero(d)))
const chisq_dist = ChiSqDist()

# KLDivergence
@inline eval_op(dist::KLDivergence, ai, bi) =
    iszero(ai) ? zero(eval_op(dist, oneunit(ai), bi)) : ai * log(ai / bi)
const kl_divergence = KLDivergence()

# GenKLDivergence
@inline eval_op(dist::GenKLDivergence, ai, bi) =
    iszero(ai) ? oftype(eval_op(dist, oneunit(ai), bi), bi) : ai * log(ai / bi) - ai + bi
const gkl_divergence = GenKLDivergence()

# RenyiDivergence
Base.@propagate_inbounds function eval_start(::RenyiDivergence, a, b)
    T = promote_type(_eltype(a), _eltype(b))
    zero(T), zero(T), T(sum(a)), T(sum(b))
end

@inline function eval_op(dist::RenyiDivergence, ai::T, bi::T) where T
    if iszero(ai)
        return zero(T), zero(T), zero(T), zero(T)
    elseif dist.is_normal
        return ai, ai * ((ai / bi)^dist.p), zero(T), zero(T)
    elseif dist.is_zero
        return ai, bi, zero(T), zero(T)
    elseif dist.is_one
        return ai, ai * log(ai / bi), zero(T), zero(T)
    else # otherwise q = ∞
        return ai, ai / bi, zero(T), zero(T)
    end
end

@inline function eval_reduce(dist::RenyiDivergence,
                             s1::Tuple{T,T,T,T},
                             s2::Tuple{T,T,T,T}) where T
    if dist.is_inf
        if iszero(s1[1])
            return (s2[1], s2[2], s1[3], s1[4])
        elseif iszero(s2[1])
            return s1
        else
            return s1[2] > s2[2] ? s1 : (s2[1], s2[2], s1[3], s1[4])
        end
    else
        return s1[1] + s2[1], s1[2] + s2[2], s1[3], s1[4]
    end
end

function eval_end(dist::RenyiDivergence, s::Tuple{T,T,T,T}) where {T <: Real}
    if dist.is_zero || dist.is_normal
        log(s[2] / s[1]) / dist.p + log(s[4] / s[3])
    elseif dist.is_one
        return s[2] / s[1] + log(s[4] / s[3])
    else # q = ∞
        log(s[2]) + log(s[4] / s[3])
    end
end

renyi_divergence(a, b, q::Real) = RenyiDivergence(q)(a, b)
# Combine docs with RenyiDivergence. Fetching the docstring with @doc causes
# problems during package compilation; see
# https://github.com/JuliaLang/julia/issues/31640
let docstring = Base.Docs.getdoc(RenyiDivergence)
    @doc docstring renyi_divergence
end

# JSDivergence

@inline function eval_op(::JSDivergence, ai::T, bi::T) where T
    u = (ai + bi) / 2
    ta = iszero(ai) ? zero(log(one(T))) : ai * log(ai) / 2
    tb = iszero(bi) ? zero(log(one(T))) : bi * log(bi) / 2
    tu = iszero(u) ? zero(log(one(T))) : u * log(u)
    ta + tb - tu
end
const js_divergence = JSDivergence()

# SpanNormDist

result_type(dist::SpanNormDist, ::Type{Ta}, ::Type{Tb}) where {Ta,Tb} =
    typeof(eval_op(dist, oneunit(Ta), oneunit(Tb)))
Base.@propagate_inbounds function eval_start(::SpanNormDist, a, b)
    d = first(a) - first(b)
    return d, d
end
eval_op(::SpanNormDist, ai, bi)  = ai - bi
@inline function eval_reduce(::SpanNormDist, s1, s2)
    min_d, max_d = s1
    if s2 > max_d
        max_d = s2
    elseif s2 < min_d
        min_d = s2
    end
    return min_d, max_d
end

eval_end(::SpanNormDist, s) = s[2] - s[1]
(::SpanNormDist)(a::Number, b::Number) = zero(promote_type(typeof(a), typeof(b)))
const spannorm_dist = SpanNormDist()

# Jaccard

eval_start(dist::Jaccard, a, b) =
    zero.(typeof.(eval_op(dist, oneunit(_eltype(a)), oneunit(_eltype(b)))))
@inline function eval_op(::Jaccard, s1, s2)
    abs_m = abs(s1 - s2)
    abs_p = abs(s1 + s2)
    abs_p - abs_m, abs_p + abs_m
end
@inline function eval_reduce(::Jaccard, s1, s2)
    @inbounds a = s1[1] + s2[1]
    @inbounds b = s1[2] + s2[2]
    a, b
end
@inline function eval_end(::Jaccard, a)
    @inbounds v = 1 - (a[1] / a[2])
    return v
end
const jaccard = Jaccard()

# BrayCurtis

eval_start(dist::BrayCurtis, a, b) =
    zero.(typeof.(eval_op(dist, oneunit(_eltype(a)), oneunit(_eltype(b)))))
@inline function eval_op(::BrayCurtis, s1, s2)
    abs_m = abs(s1 - s2)
    abs_p = abs(s1 + s2)
    abs_m, abs_p
end
@inline function eval_reduce(::BrayCurtis, s1, s2)
    @inbounds a = s1[1] + s2[1]
    @inbounds b = s1[2] + s2[2]
    a, b
end
@inline function eval_end(::BrayCurtis, a)
    @inbounds v = a[1] / a[2]
    return v
end
const braycurtis = BrayCurtis()

# Tanimoto

@inline eval_start(::RogersTanimoto, _, _) = 0, 0, 0, 0
@inline function eval_op(::RogersTanimoto, s1, s2)
    tt = s1 && s2
    tf = s1 && !s2
    ft = !s1 && s2
    ff = !s1 && !s2
    tt, tf, ft, ff
end
@inline function eval_reduce(::RogersTanimoto, s1, s2)
    @inbounds begin
        a = s1[1] + s2[1]
        b = s1[2] + s2[2]
        c = s1[3] + s2[3]
        d = s1[4] + s2[4]
    end
    a, b, c, d
end
@inline function eval_end(::RogersTanimoto, a)
    @inbounds numerator = 2(a[2] + a[3])
    @inbounds denominator = a[1] + a[4] + 2(a[2] + a[3])
    numerator / denominator
end
const rogerstanimoto = RogersTanimoto()

# Deviations

(::MeanAbsDeviation)(a, b) = cityblock(a, b) / length(a)
const meanad = MeanAbsDeviation()

(::MeanSqDeviation)(a, b) = sqeuclidean(a, b) / length(a)
const msd = MeanSqDeviation()

(::RMSDeviation)(a, b) = sqrt(MeanSqDeviation()(a, b))
const rmsd = RMSDeviation()

function (::NormRMSDeviation)(a, b)
    amin, amax = extrema(a)
    return RMSDeviation()(a, b) / (amax - amin)
end
const nrmsd = NormRMSDeviation()


###########################################################
#
#  Special method
#
###########################################################

# SqEuclidean/Euclidean
function _pairwise!(dist::Union{SqEuclidean,Euclidean}, r::AbstractMatrix,
                    a::AbstractMatrix, b::AbstractMatrix)
    require_one_based_indexing(r, a, b)
    m, na, nb = get_pairwise_dims(r, a, b)
    # the following checks if a'*b can be stored in r directly, it fails for complex eltypes
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(b)))) === eltype(r)
    R = inplace ? mul!(r, a', b) : a'b
    sa2 = sum(abs2, a, dims=1)
    sb2 = sum(abs2, b, dims=1)
    z² = zero(real(eltype(R)))
    @inbounds if dist.thresh <= 0
        # If there's no chance of triggering the threshold, we can use @simd
        for j = 1:nb
            sb = sb2[j]
            @simd for i = 1:na
                r[i, j] = eval_end(dist, (max(sa2[i] + sb - 2real(R[i, j]), z²)))
            end
        end
    else
        for j = 1:nb
            sb = sb2[j]
            for i = 1:na
                selfterms = sa2[i] + sb
                v = max(selfterms - 2real(R[i, j]), z²)
                if v < dist.thresh * selfterms
                    # The distance is likely to be inaccurate, recalculate directly
                    # This reflects the following:
                    #   while sqrt(x+ϵ) ≈ sqrt(x) + O(ϵ/sqrt(x)) when |x| >> ϵ,
                    #         sqrt(x+ϵ) ≈ O(sqrt(ϵ))             otherwise.
                    v = zero(v)
                    for k = 1:m
                        v += abs2(a[k, i] - b[k, j])
                    end
                end
                r[i, j] = eval_end(dist, v)
            end
        end
    end
    r
end

function _pairwise!(dist::Union{SqEuclidean,Euclidean}, r::AbstractMatrix, a::AbstractMatrix)
    require_one_based_indexing(r, a)
    m, n = get_pairwise_dims(r, a)
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(a)))) === eltype(r)
    # the following checks if a'*b can be stored in r directly, it fails for complex eltypes
    R = inplace ? mul!(r, a', a) : a'a
    sa2 = sum(abs2, a, dims=1)
    safe = dist.thresh <= 0
    z² = zero(real(eltype(R)))
    @inbounds for j = 1:n
        for i = 1:(j - 1)
            r[i, j] = r[j, i]
        end
        r[j, j] = zero(eltype(r))
        sa2j = sa2[j]
        if safe
            @simd for i = (j + 1):n
                r[i, j] = eval_end(dist, (max(sa2[i] + sa2j - 2real(R[i, j]), z²)))
            end
        else
            for i = (j + 1):n
                selfterms = sa2[i] + sa2j
                v = max(selfterms - 2real(R[i, j]), z²)
                if v < dist.thresh * selfterms
                    v = zero(v)
                    for k = 1:m
                        v += abs2(a[k, i] - a[k, j])
                    end
                end
                r[i, j] = eval_end(dist, v)
            end
        end
    end
    r
end

# Weighted SqEuclidean/Euclidean
function _pairwise!(dist::Union{WeightedSqEuclidean,WeightedEuclidean}, r::AbstractMatrix,
                    a::AbstractMatrix, b::AbstractMatrix)
    require_one_based_indexing(r, a, b)
    w = dist.weights
    m, na, nb = get_pairwise_dims(length(w), r, a, b)

    sa2 = wsumsq_percol(w, a)
    sb2 = wsumsq_percol(w, b)
    # the following checks if a'*b can be stored in r directly, it fails for complex eltypes
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(b)))) === eltype(r)
    R = inplace ? mul!(r, a', w .* b) : a'*Diagonal(w)*b
    z² = zero(real(eltype(R)))
    for j = 1:nb
        @simd for i = 1:na
            @inbounds r[i, j] = eval_end(dist, max(sa2[i] + sb2[j] - 2real(R[i, j]), z²))
        end
    end
    r
end
function _pairwise!(dist::Union{WeightedSqEuclidean,WeightedEuclidean}, r::AbstractMatrix,
                    a::AbstractMatrix)
    require_one_based_indexing(r, a)
    w = dist.weights
    m, n = get_pairwise_dims(length(w), r, a)

    sa2 = wsumsq_percol(w, a)
    # the following checks if a'*b can be stored in r directly, it fails for complex eltypes
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(a)))) === eltype(r)
    R = inplace ? mul!(r, a', w .* a) : a'*Diagonal(w)*a
    z² = zero(real(eltype(R)))

    @inbounds for j = 1:n
        for i = 1:(j - 1)
            r[i, j] = r[j, i]
        end
        r[j, j] = zero(eltype(r))
        @simd for i = (j + 1):n
            r[i, j] = eval_end(dist, max(sa2[i] + sa2[j] - 2real(R[i, j]), z²))
        end
    end
    r
end

# MeanSqDeviation, RMSDeviation, NormRMSDeviation
function _pairwise!(dist::MeanSqDeviation, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    _pairwise!(SqEuclidean(), r, a, b)
    # TODO: Replace by rdiv!(r, size(a, 1)) once julia compat ≥v1.2
    s = size(a, 1)
    @simd for I in eachindex(r)
        @inbounds r[I] /= s
    end
    return r
end
_pairwise!(dist::RMSDeviation, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix) =
    sqrt!(_pairwise!(MeanSqDeviation(), r, a, b))
function _pairwise!(dist::NormRMSDeviation, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    _pairwise!(RMSDeviation(), r, a, b)
    @views for (i, j) in zip(axes(r, 1), axes(a, 2))
        amin, amax = extrema(a[:,j])
        r[i,:] ./= amax - amin
    end
    return r
end

function _pairwise!(dist::MeanSqDeviation, r::AbstractMatrix, a::AbstractMatrix)
    _pairwise!(SqEuclidean(), r, a)
    # TODO: Replace by rdiv!(r, size(a, 1)) once julia compat ≥v1.2
    s = size(a, 1)
    @simd for I in eachindex(r)
        @inbounds r[I] /= s
    end
    return r
end
_pairwise!(dist::RMSDeviation, r::AbstractMatrix, a::AbstractMatrix) =
    sqrt!(_pairwise!(MeanSqDeviation(), r, a))
function _pairwise!(dist::NormRMSDeviation, r::AbstractMatrix, a::AbstractMatrix)
    _pairwise!(RMSDeviation(), r, a)
    @views for (i, j) in zip(axes(r, 1), axes(a, 2))
        amin, amax = extrema(a[:,j])
        r[i,:] ./= amax - amin
    end
    return r
end

# CosineDist

function _pairwise!(::CosineDist, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    require_one_based_indexing(r, a, b)
    m, na, nb = get_pairwise_dims(r, a, b)
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(b)))) === eltype(r)
    R = inplace ? mul!(r, a', b) : a'b
    ra = norm_percol(a)
    rb = norm_percol(b)
    for j = 1:nb
        @simd for i = 1:na
            @inbounds r[i, j] = max(1 - R[i, j] / (ra[i] * rb[j]), 0)
        end
    end
    r
end
function _pairwise!(::CosineDist, r::AbstractMatrix, a::AbstractMatrix)
    require_one_based_indexing(r, a)
    m, n = get_pairwise_dims(r, a)
    inplace = promote_type(eltype(r), typeof(oneunit(eltype(a))'oneunit(eltype(a)))) === eltype(r)
    R = inplace ? mul!(r, a', a) : a'a
    ra = norm_percol(a)
    @inbounds for j = 1:n
        for i = 1:(j - 1)
            r[i, j] = r[j, i]
        end
        r[j, j] = zero(eltype(r))
        @simd for i = j + 1:n
            r[i, j] = max(1 - R[i, j] / (ra[i] * ra[j]), 0)
        end
    end
    r
end

# CorrDist
# This part of codes is accelerated because:
# 1. It calls the accelerated `_pairwise` specilization for CosineDist
# 2. pre-calculated `_centralize_colwise` avoids four times of redundant computations
#    of `_centralize` -- ~4x speed up
_centralize_colwise(x::AbstractMatrix) = x .- mean(x, dims=1)
_pairwise!(::CorrDist, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix) =
    _pairwise!(CosineDist(), r, _centralize_colwise(a), _centralize_colwise(b))
_pairwise!(::CorrDist, r::AbstractMatrix, a::AbstractMatrix) =
    _pairwise!(CosineDist(), r, _centralize_colwise(a))

# Generic concepts and functions

# a premetric is a function d that satisfies:
#
#   d(x, y) >= 0
#   d(x, x) = 0
#
abstract type PreMetric end

# a semimetric is a function d that satisfies:
#
#   d(x, y) >= 0
#   d(x, x) = 0
#   d(x, y) = d(y, x)
#
abstract type SemiMetric <: PreMetric end

# a metric is a semimetric that satisfies triangle inequality:
#
#   d(x, y) + d(y, z) >= d(x, z)
#
abstract type Metric <: SemiMetric end

evaluate(dist::PreMetric, a, b) = dist(a, b)

# Generic functions

"""
    result_type(dist, Ta::Type, Tb::Type) -> T
    result_type(dist, a, b) -> T

Infer the result type of metric `dist` with input types `Ta` and `Tb`, or element types
of iterators `a` and `b`.
"""
result_type(dist, a, b) = result_type(dist, _eltype(a), _eltype(b))
result_type(f, a::Type, b::Type) = typeof(f(oneunit(a), oneunit(b))) # don't require `PreMetric` subtyping


_eltype(a) = __eltype(Base.IteratorEltype(a), a)
_eltype(::Type{T}) where {T} = eltype(T) === T ? T : _eltype(eltype(T))
_eltype(::Type{Union{Missing, T}}) where {T} = Union{Missing, T}

__eltype(::Base.HasEltype, a) = _eltype(eltype(a))
__eltype(::Base.EltypeUnknown, a) = _eltype(typeof(first(a)))

# Generic column-wise evaluation

"""
    colwise!(metric::PreMetric, r::AbstractArray, a, b)

Compute distances between corresponding elements of the iterable collections
`a` and `b` according to distance `metric`, and store the result in `r`.

`a` and `b` must have the same number of elements, `r` must be an array of length
`length(a) == length(b)`.
"""
function colwise!(metric::PreMetric, r::AbstractArray, a, b)
    require_one_based_indexing(r)
    n = length(a)
    length(b) == n || throw(DimensionMismatch("iterators have different lengths"))
    length(r) == n || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for (j, ab) in enumerate(zip(a, b))
        r[j] = metric(ab...)
    end
    r
end

function colwise!(metric::PreMetric, r::AbstractArray, a::AbstractVector, b::AbstractMatrix)
    require_one_based_indexing(r)
    n = size(b, 2)
    length(r) == n || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for (rj, bj) in enumerate(axes(b, 2))
        r[rj] = metric(a, view(b, :, bj))
    end
    r
end

function colwise!(metric::PreMetric, r::AbstractArray, a::AbstractMatrix, b::AbstractVector)
    require_one_based_indexing(r)
    n = size(a, 2)
    length(r) == n || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for (rj, aj) in enumerate(axes(a, 2))
        r[rj] = metric(view(a, :, aj), b)
    end
    r
end

"""
    colwise!(metric::PreMetric, r::AbstractArray,
             a::AbstractMatrix, b::AbstractMatrix)
    colwise!(metric::PreMetric, r::AbstractArray,
             a::AbstractVector, b::AbstractMatrix)
    colwise!(metric::PreMetric, r::AbstractArray,
             a::AbstractMatrix, b::AbstractVector)

Compute distances between each corresponding columns of `a` and `b` according
to distance `metric`, and store the result in `r`. Exactly one of `a` or `b`
can be a vector, in which case the distance between that vector and all columns
of the other matrix are computed.

`a` and `b` must have the same number of columns if neither of the two is a
vector. `r` must be an array of length `maximum(size(a, 2), size(b, 2))`.

!!! note
    If both `a` and `b` are vectors, the generic, iterator-based method of
    `colwise` applies.
"""
function colwise!(metric::PreMetric, r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    require_one_based_indexing(r, a, b)
    n = get_common_ncols(a, b)
    length(r) == n || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for j in 1:n
        r[j] = metric(view(a, :, j), view(b, :, j))
    end
    r
end

"""
    colwise(metric::PreMetric, a, b)

Compute distances between corresponding elements of the iterable collections
`a` and `b` according to distance `metric`.

`a` and `b` must have the same number of elements (`length(a) == length(b)`).
"""
function colwise(metric::PreMetric, a, b)
    n = get_common_length(a, b)
    r = Vector{result_type(metric, a, b)}(undef, n)
    colwise!(metric, r, a, b)
end

"""
    colwise(metric::PreMetric, a::AbstractMatrix, b::AbstractMatrix)
    colwise(metric::PreMetric, a::AbstractVector, b::AbstractMatrix)
    colwise(metric::PreMetric, a::AbstractMatrix, b::AbstractVector)

Compute distances between corresponding columns of `a` and `b` according to
distance `metric`. Exactly one of `a` or `b` can be a vector, in which case the
distance between that vector and all columns of the other matrix are computed.

`a` and `b` must have the same number of columns if neither of the two is a
vector.

!!! note
    If both `a` and `b` are vectors, the generic, iterator-based method of
    `colwise` applies.
"""
function colwise(metric::PreMetric, a::AbstractMatrix, b::AbstractMatrix)
    n = get_common_ncols(a, b)
    r = Vector{result_type(metric, a, b)}(undef, n)
    colwise!(metric, r, a, b)
end

function colwise(metric::PreMetric, a::AbstractVector, b::AbstractMatrix)
    n = size(b, 2)
    r = Vector{result_type(metric, a, b)}(undef, n)
    colwise!(metric, r, a, b)
end

function colwise(metric::PreMetric, a::AbstractMatrix, b::AbstractVector)
    n = size(a, 2)
    r = Vector{result_type(metric, a, b)}(undef, n)
    colwise!(metric, r, a, b)
end


# Generic pairwise evaluation

function _pairwise!(metric::PreMetric, r::AbstractMatrix, a, b=a)
    require_one_based_indexing(r)
    na = length(a)
    nb = length(b)
    size(r) == (na, nb) || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for (j, bj) in enumerate(b), (i, ai) in enumerate(a)
        r[i, j] = metric(ai, bj)
    end
    r
end

function _pairwise!(metric::PreMetric, r::AbstractMatrix,
                    a::AbstractMatrix, b::AbstractMatrix=a)
    require_one_based_indexing(r, a, b)
    na = size(a, 2)
    nb = size(b, 2)
    size(r) == (na, nb) || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for j = 1:size(b, 2)
        bj = view(b, :, j)
        for i = 1:size(a, 2)
            r[i, j] = metric(view(a, :, i), bj)
        end
    end
    r
end

function _pairwise!(metric::SemiMetric, r::AbstractMatrix, a)
    require_one_based_indexing(r)
    n = length(a)
    size(r) == (n, n) || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for (j, aj) in enumerate(a), (i, ai) in enumerate(a)
        r[i, j] = if i > j
            metric(ai, aj)
        elseif i == j
            zero(eltype(r))
        else
            r[j, i]
        end
    end
    r
end

function _pairwise!(metric::SemiMetric, r::AbstractMatrix, a::AbstractMatrix)
    require_one_based_indexing(r)
    n = size(a, 2)
    size(r) == (n, n) || throw(DimensionMismatch("Incorrect size of r."))
    @inbounds for j = 1:n
        for i = 1:(j - 1)
            r[i, j] = r[j, i]   # leveraging the symmetry of SemiMetric
        end
        r[j, j] = zero(eltype(r))
        aj = view(a, :, j)
        for i = (j + 1):n
            r[i, j] = metric(view(a, :, i), aj)
        end
    end
    r
end

function deprecated_dims(dims::Union{Nothing,Integer})
    if dims === nothing
        Base.depwarn("implicit `dims=2` argument now has to be passed explicitly " *
                     "to specify that distances between columns should be computed",
                     :pairwise!)
        return 2
    else
        return dims
    end
end

"""
    pairwise!(metric::PreMetric, r::AbstractMatrix,
              a::AbstractMatrix, b::AbstractMatrix=a; dims)

Compute distances between each pair of rows (if `dims=1`) or columns (if `dims=2`)
in `a` and `b` according to distance `metric`, and store the result in `r`.
If a single matrix `a` is provided, compute distances between its rows or columns.

`a` and `b` must have the same numbers of columns if `dims=1`, or of rows if `dims=2`.
`r` must be a matrix with size `size(a, dims) × size(b, dims)`.
"""
function pairwise!(metric::PreMetric, r::AbstractMatrix,
                   a::AbstractMatrix, b::AbstractMatrix;
                   dims::Union{Nothing,Integer}=nothing)
    dims = deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    if dims == 1
        na, ma = size(a)
        nb, mb = size(b)
        ma == mb || throw(DimensionMismatch("The numbers of columns in a and b " *
                                            "must match (got $ma and $mb)."))
    else
        ma, na = size(a)
        mb, nb = size(b)
        ma == mb || throw(DimensionMismatch("The numbers of rows in a and b " *
                                            "must match (got $ma and $mb)."))
    end
    size(r) == (na, nb) ||
        throw(DimensionMismatch("Incorrect size of r (got $(size(r)), expected $((na, nb)))."))
    if dims == 1
        _pairwise!(metric, r, permutedims(a), permutedims(b))
    else
        _pairwise!(metric, r, a, b)
    end
end

function pairwise!(metric::PreMetric, r::AbstractMatrix, a::AbstractMatrix;
                   dims::Union{Nothing,Integer}=nothing)
    dims = deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    if dims == 1
        n, m = size(a)
    else
        m, n = size(a)
    end
    size(r) == (n, n) ||
        throw(DimensionMismatch("Incorrect size of r (got $(size(r)), expected $((n, n)))."))
    if dims == 1
        _pairwise!(metric, r, permutedims(a))
    else
        _pairwise!(metric, r, a)
    end
end

"""
    pairwise!(metric::PreMetric, r::AbstractMatrix, a, b=a)

Compute distances between each element of collection `a` and each element of
collection `b` according to distance `metric`, and store the result in `r`.
If a single iterable `a` is provided, compute distances between its elements.

`r` must be a matrix with size `length(a) × length(b)`.
"""
pairwise!(metric::PreMetric, r::AbstractMatrix, a, b) = _pairwise!(metric, r, a, b)
pairwise!(metric::PreMetric, r::AbstractMatrix, a) = _pairwise!(metric, r, a)

"""
    pairwise(metric::PreMetric, a::AbstractMatrix, b::AbstractMatrix=a; dims)

Compute distances between each pair of rows (if `dims=1`) or columns (if `dims=2`)
in `a` and `b` according to distance `metric`. If a single matrix `a` is provided,
compute distances between its rows or columns.

`a` and `b` must have the same numbers of columns if `dims=1`, or of rows if `dims=2`.
"""
function pairwise(metric::PreMetric, a::AbstractMatrix, b::AbstractMatrix;
                  dims::Union{Nothing,Integer}=nothing)
    dims = deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    m = size(a, dims)
    n = size(b, dims)
    r = Matrix{result_type(metric, a, b)}(undef, m, n)
    pairwise!(metric, r, a, b, dims=dims)
end

function pairwise(metric::PreMetric, a::AbstractMatrix;
                  dims::Union{Nothing,Integer}=nothing)
    dims = deprecated_dims(dims)
    dims in (1, 2) || throw(ArgumentError("dims should be 1 or 2 (got $dims)"))
    n = size(a, dims)
    r = Matrix{result_type(metric, a, a)}(undef, n, n)
    pairwise!(metric, r, a, dims=dims)
end

"""
    pairwise(metric::PreMetric, a, b=a)

Compute distances between each element of collection `a` and each element of
collection `b` according to distance `metric`. If a single iterable `a` is
provided, compute distances between its elements.
"""
function pairwise(metric::PreMetric, a, b)
    m = length(a)
    n = length(b)
    r = Matrix{result_type(metric, a, b)}(undef, m, n)
    _pairwise!(metric, r, a, b)
end

function pairwise(metric::PreMetric, a)
    n = length(a)
    r = Matrix{result_type(metric, a, a)}(undef, n, n)
    _pairwise!(metric, r, a)
end

using BenchmarkTools
using Distances
using Printf

include("benchmarks.jl")

# BenchmarkTools stores things in a Dict so it loses ordering but we want to print the table
# in a special order. Therefore define an order here:

order = [
    :SqEuclidean,
    :Euclidean,
    :PeriodicEuclidean,
    :Cityblock,
    :TotalVariation,
    :Chebyshev,
    :Minkowski,
    :Hamming,
    :CosineDist,
    :CorrDist,
    :ChiSqDist,
    :KLDivergence,
    :RenyiDivergence,
    :RenyiDivergence,
    :RenyiDivergence,
    :RenyiDivergence,
    :JSDivergence,
    :BhattacharyyaDist,
    :HellingerDist,
    :WeightedSqEuclidean,
    :WeightedEuclidean,
    :WeightedCityblock,
    :WeightedMinkowski,
    :WeightedHamming,
    :SqMahalanobis,
    :Mahalanobis,
    :Haversine,
    :BrayCurtis,
]

BenchmarkTools.DEFAULT_PARAMETERS.seconds = 2.0 # Long enough

# Tuning
if !isfile(@__DIR__, "params.json")
    tuning = tune!(SUITE; verbose = true);
    BenchmarkTools.save("params.json", "SUITE", params(SUITE))
end
loadparams!(SUITE, BenchmarkTools.load("params.json")[1], :evals, :samples);

# Run and judge
results = run(SUITE; verbose = true)
judgement = minimum(results)

# Output the comparison table
getname(T::DataType) = T.name.name

function print_table(judgement)
    for typ in ("colwise", "pairwise")
        io = IOBuffer()
        println(io, "|  distance  |  loop  |  $typ  |  gain  |")
        println(io, "|----------- | -------| ----------| -------|")
        sorted_distances = sort(collect(judgement[typ]), by = y -> findfirst(x -> x == getname(y[1]), order))

        for (dist, result) in sorted_distances
            t_loop = BenchmarkTools.time(result["loop"])
            t_spec = BenchmarkTools.time(result["specialized"])
            print(io, "| ", getname(dist), " |")
            print(io, @sprintf("%9.6fs | %9.6fs | %7.4f |\n", t_loop / 1e9, t_spec / 1e9, (t_loop / t_spec)))
        end
        print(stdout, String(take!(io)))
        println()
    end
end

print_table(judgement)

"""
    Haversine(radius=6_371_000)

The haversine distance between two locations on a sphere of given `radius`, whose
default value is 6,371,000, i.e., the Earth's (volumetric) mean radius in meters; cf.
[NASA's Earth Fact Sheet](https://nssdc.gsfc.nasa.gov/planetary/factsheet/earthfact.html).

Locations are described with longitude and latitude in degrees.
The computed distance has the unit of the radius.
"""
struct Haversine{T<:Number} <: Metric
    radius::T
end
Haversine{T}() where {T<:Number} = Haversine(T(6_371_000))
Haversine() = Haversine{Int}()

function (dist::Haversine)(x, y)
    length(x) == length(y) == 2 || haversine_error(dist)

    @inbounds λ₁, φ₁ = x
    @inbounds λ₂, φ₂ = y

    Δλ = λ₂ - λ₁  # longitudes
    Δφ = φ₂ - φ₁  # latitudes

    # haversine formula
    a = sind(Δφ/2)^2 + cosd(φ₁)*cosd(φ₂)*sind(Δλ/2)^2

    # distance on the sphere
    2 * (dist.radius * asin( min(√a, one(a)) )) # take care of floating point errors
end

haversine(x, y, radius::Number=6_371_000) = Haversine(radius)(x, y)

@noinline haversine_error(dist) = throw(ArgumentError("expected both inputs to have length 2 in $dist distance"))

result_type(::Haversine{T1}, ::Type{T2}, ::Type{T3}) where {T1<:Number,T2<:Number,T3<:Number} =
    float(promote_type(T1, T2, T3))

"""
    SphericalAngle()

The spherical angle distance between two locations on a sphere.

Locations are described with two angles, longitude and latitude, in radians.
The distance is computed with the haversine formula and also has units of radians.
"""
struct SphericalAngle <: Metric end

function (dist::SphericalAngle)(x, y)
    length(x) == length(y) == 2 || haversine_error(dist)

    @inbounds λ₁, φ₁ = x
    @inbounds λ₂, φ₂ = y

    Δλ = λ₂ - λ₁  # longitudes
    Δφ = φ₂ - φ₁  # latitudes

    # haversine formula
    a = sin(Δφ/2)^2 + cos(φ₁)*cos(φ₂)*sin(Δλ/2)^2

    # distance on the sphere
    2 * asin( min(√a, one(a)) ) # take care of floating point errors
end

const spherical_angle = SphericalAngle()

result_type(::SphericalAngle, ::Type{T1}, ::Type{T2}) where {T1<:Number,T2<:Number} = float(promote_type(T1, T2))

using ChainRulesCore
using ChainRulesTestUtils
using StableRNGs

@testset "ChainRulesCore extension" begin
    n = 4
    rng = StableRNG(100)
    x = randn(rng, n)
    y = randn(rng, n)
    X = randn(rng, n, 3)
    Y = randn(rng, n, 3)
    Xrep = repeat(x, 1, 3)
    Yrep = repeat(y, 1, 3)

    @testset for metric in (SqEuclidean(), Euclidean())
        # Single evaluation
        test_rrule(metric ⊢ NoTangent(), x, y)
        test_rrule(metric ⊢ NoTangent(), x, x)

        for A in (X, Xrep)
            # Column-wise distance
            test_rrule(colwise, metric ⊢ NoTangent(), A, A)

            # Pairwise distances
            # Finite differencing yields impressively inaccurate derivatives for `Euclidean`,
            # see https://github.com/FluxML/Zygote.jl/blob/45bf883491d2b52580d716d577e2fa8577a07230/test/gradcheck.jl#L1206
            kwargs = metric isa Euclidean ? (rtol=1e-3, atol=1e-3) : ()
            test_rrule(pairwise, metric ⊢ NoTangent(), A; kwargs...)
            test_rrule(pairwise, metric ⊢ NoTangent(), A; fkwargs=(dims=1,), kwargs...)
            test_rrule(pairwise, metric ⊢ NoTangent(), A; fkwargs=(dims=2,), kwargs...)
            test_rrule(pairwise, metric ⊢ NoTangent(), A, A; kwargs...)
            test_rrule(pairwise, metric ⊢ NoTangent(), A, A; fkwargs=(dims=1,), kwargs...)
            test_rrule(pairwise, metric ⊢ NoTangent(), A, A; fkwargs=(dims=2,), kwargs...)

            for B in (Y, Yrep)
                # Column-wise distance
                test_rrule(colwise, metric ⊢ NoTangent(), A, B)

                # Pairwise distances
                test_rrule(pairwise, metric ⊢ NoTangent(), A, B)
                test_rrule(pairwise, metric ⊢ NoTangent(), A, B; fkwargs=(dims=1,))
                test_rrule(pairwise, metric ⊢ NoTangent(), A, B; fkwargs=(dims=2,))
            end
        end
    end
end

# Bregman divergence

"""
Implements the Bregman divergence, a friendly introduction to which can be found
[here](http://mark.reid.name/blog/meet-the-bregman-divergences.html).
Bregman divergences are a minimal implementation of the "mean-minimizer" property.

It is assumed that the (convex differentiable) function F maps vectors (of any type or size) to real numbers.
The inner product used is `Base.dot`, but one can be passed in either by defining `inner` or by
passing in a keyword argument. If an analytic gradient isn't available, Julia offers a suite
of good automatic differentiation packages.

function evaluate(dist::Bregman, p::AbstractVector, q::AbstractVector)
"""
struct Bregman{T1 <: Function, T2 <: Function, T3 <: Function} <: PreMetric
    F::T1
    ∇::T2
    inner::T3
end

# Default costructor.
Bregman(F, ∇) =  Bregman(F, ∇, LinearAlgebra.dot)

# Evaluation fuction
function (dist::Bregman)(p, q)
    # Create cache vals.
    FP_val = dist.F(p)
    FQ_val = dist.F(q)
    DQ_val = dist.∇(q)
    p_size = length(p)
    # Check F codomain.
    if !(isa(FP_val, Real) && isa(FQ_val, Real))
        throw(ArgumentError("F Codomain Error: F doesn't map the vectors to real numbers"))
    end
    # Check vector size.
    if p_size != length(q)
        throw(DimensionMismatch("The vector p ($(size(p))) and q ($(size(q))) are different sizes."))
    end
    # Check gradient size.
    if length(DQ_val) != p_size
        throw(DimensionMismatch("The gradient result is not the same size as p and q"))
    end
    # Return the Bregman divergence.
    return FP_val - FQ_val - dist.inner(DQ_val, p .- q)
end

# Convenience function.
bregman(F, ∇, x, y; inner = LinearAlgebra.dot) = Bregman(F, ∇, inner)(x, y)

# Mahalanobis distances

"""
    Mahalanobis(Q; skipchecks=false) <: Metric

Create a Mahalanobis distance (i.e., a bilinear form) with covariance matrix `Q`.
Upon construction, both symmetry/self-adjointness and positive semidefiniteness are checked,
where the latter check can be skipped by passing the keyword argument `skipchecks = true`.

# Example:
```julia
julia> A = collect(reshape(1:9, 3, 3)); Q = A'A;

julia> dist = Mahalanobis(Q)
Mahalanobis{Matrix{Int64}}([14 32 50; 32 77 122; 50 122 194])

julia> dist = Mahalanobis(A, skipchecks=true)
┌ Warning: matrix is not symmetric/Hermitian
└ @ Distances ...
Mahalanobis{Matrix{Int64}}([1 4 7; 2 5 8; 3 6 9])
"""
struct Mahalanobis{M<:AbstractMatrix} <: Metric
    qmat::M
    function Mahalanobis(Q::AbstractMatrix; skipchecks::Bool=false)
        # TODO: turn the warnings into errors in next breaking release
        ishermitian(Q) || @warn "matrix is not symmetric/Hermitian"
        if !skipchecks
            eigmin(Q) ≥ 0 || @warn "matrix is not positive semidefinite"
        end
        return new{typeof(Q)}(Q)
    end
end

"""
    SqMahalanobis(Q; skipchecks=false) <: Metric

Create a squared Mahalanobis distance (i.e., a bilinear form) with covariance matrix `Q`.
Upon construction, both symmetry/self-adjointness and positive semidefiniteness are checked,
where the latter check can be skipped by passing the keyword argument `skipchecks = true`.

# Example:
```julia
julia> A = collect(reshape(1:9, 3, 3)); Q = A'A;

julia> dist = SqMahalanobis(Q)
SqMahalanobis{Matrix{Int64}}([14 32 50; 32 77 122; 50 122 194])

julia> dist = SqMahalanobis(A, skipchecks=true)
┌ Warning: matrix is not symmetric/Hermitian
└ @ Distances ...
SqMahalanobis{Matrix{Int64}}([1 4 7; 2 5 8; 3 6 9])
"""
struct SqMahalanobis{M<:AbstractMatrix} <: SemiMetric
    qmat::M
    function SqMahalanobis(Q::AbstractMatrix; skipchecks::Bool=false)
        # TODO: turn the warnings into errors in next breaking release
        ishermitian(Q) || @warn "matrix is not symmetric/Hermitian"
        if !skipchecks
            eigmin(Q) ≥ 0 || @warn "matrix is not positive semidefinite"
        end
        return new{typeof(Q)}(Q)
    end
end

function result_type(d::Mahalanobis, ::Type{T1}, ::Type{T2}) where {T1,T2}
    z = zero(T1) - zero(T2)
    return typeof(sqrt(z * zero(eltype(d.qmat)) * z))
end

function result_type(d::SqMahalanobis, ::Type{T1}, ::Type{T2}) where {T1,T2}
    z = zero(T1) - zero(T2)
    return typeof(z * zero(eltype(d.qmat)) * z)
end

# TODO: merge the following two once we lift the lower bound for julia (above v1.4?)
function (dist::SqMahalanobis)(a::AbstractVector, b::AbstractVector)
    if length(a) != length(b)
        throw(DimensionMismatch("first array has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end

    Q = dist.qmat
    z = a - b
    return dot(z, Q * z)
end
function (dist::Mahalanobis)(a::AbstractVector, b::AbstractVector)
    if length(a) != length(b)
        throw(DimensionMismatch("first array has length $(length(a)) which does not match the length of the second, $(length(b))."))
    end

    Q = dist.qmat
    z = a - b
    return sqrt(dot(z, Q * z))
end

sqmahalanobis(a::AbstractVector, b::AbstractVector, Q::AbstractMatrix) = SqMahalanobis(Q)(a, b)
mahalanobis(a::AbstractVector, b::AbstractVector, Q::AbstractMatrix) = Mahalanobis(Q)(a, b)

function _colwise!(dist, r, a, b)
    Q = dist.qmat
    get_colwise_dims(size(Q, 1), r, a, b)
    z = a .- b
    dot_percol!(r, Q * z, z)
end

function colwise!(dist::SqMahalanobis, r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    _colwise!(dist, r, a, b)
end
function colwise!(dist::SqMahalanobis, r::AbstractArray, a::AbstractVector, b::AbstractMatrix)
    _colwise!(dist, r, a, b)
end
function colwise!(dist::SqMahalanobis, r::AbstractArray, a::AbstractMatrix, b::AbstractVector)
    _colwise!(dist, r, a, b)
end

function colwise!(dist::Mahalanobis, r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    sqrt!(_colwise!(dist, r, a, b))
end
function colwise!(dist::Mahalanobis, r::AbstractArray, a::AbstractVector, b::AbstractMatrix)
    sqrt!(_colwise!(dist, r, a, b))
end
function colwise!(dist::Mahalanobis, r::AbstractArray, a::AbstractMatrix, b::AbstractVector)
    sqrt!(_colwise!(dist, r, a, b))
end

function _pairwise!(dist::Union{SqMahalanobis,Mahalanobis}, r::AbstractMatrix, a::AbstractMatrix, b::AbstractMatrix)
    Q = dist.qmat
    m, na, nb = get_pairwise_dims(size(Q, 1), r, a, b)

    Qa = Q * a
    Qb = Q * b
    sa2 = dot_percol(a, Qa)
    sb2 = dot_percol(b, Qb)
    mul!(r, a', Qb)

    for j = 1:nb
        @simd for i = 1:na
            @inbounds r[i, j] = eval_end(dist, max(sa2[i] + sb2[j] - 2 * r[i, j], 0))
        end
    end
    r
end

function _pairwise!(dist::Union{SqMahalanobis,Mahalanobis}, r::AbstractMatrix, a::AbstractMatrix)
    Q = dist.qmat
    m, n = get_pairwise_dims(size(Q, 1), r, a)

    Qa = Q * a
    sa2 = dot_percol(a, Qa)
    mul!(r, a', Qa)

    for j = 1:n
        for i = 1:(j - 1)
            @inbounds r[i, j] = r[j, i]
        end
        r[j, j] = 0
        for i = (j + 1):n
            @inbounds r[i, j] = eval_end(dist, max(sa2[i] + sa2[j] - 2 * r[i, j], 0))
        end
    end
    r
end

eval_end(::SqMahalanobis, x) = x
eval_end(::Mahalanobis, x) = sqrt(x)

using BenchmarkTools
using Distances

const SUITE = BenchmarkGroup()

function create_distances(w, Q)
    dists = [
        SqEuclidean(),
        Euclidean(),
        PeriodicEuclidean(w),
        Cityblock(),
        TotalVariation(),
        Chebyshev(),
        Minkowski(3.0),
        Hamming(),

        CosineDist(),
        CorrDist(),
        ChiSqDist(),

        BhattacharyyaDist(),
        HellingerDist(),

        # Haversine(6371.),

        BrayCurtis(),

        WeightedSqEuclidean(w),
        WeightedEuclidean(w),
        WeightedCityblock(w),
        WeightedMinkowski(w, 3.0),
        WeightedHamming(w),

        SqMahalanobis(Q),
        Mahalanobis(Q),
    ]

    divs = [
        KLDivergence(),
        RenyiDivergence(0),
        RenyiDivergence(1),
        RenyiDivergence(2),
        RenyiDivergence(Inf),
        JSDivergence(),
    ]
    return dists, divs
end

###########
# Colwise #
###########

SUITE["colwise"] = BenchmarkGroup()

function evaluate_colwise(dist, x, y)
    n = size(x, 2)
    T = typeof(evaluate(dist, x[:, 1], y[:, 1]))
    r = Vector{T}(undef, n)
    for j = 1:n
        r[j] = @views evaluate(dist, x[:, j], y[:, j])
    end
    return r
end

function add_colwise_benchmarks!(SUITE)

    m = 200
    n = 10000

    x = rand(m, n)
    y = rand(m, n)

    p = x
    q = y
    for i = 1:n
        p[:, i] /= sum(x[:, i])
        q[:, i] /= sum(y[:, i])
    end

    w = rand(m)

    Q = rand(m, m)
    Q = Q' * Q

    _dists, divs = create_distances(w, Q)

    for (dists, (a, b)) in [(_dists, (x,y)), (divs, (p,q))]
        for dist in (dists)
            Tdist = typeof(dist)
            SUITE["colwise"][Tdist] = BenchmarkGroup()
            SUITE["colwise"][Tdist]["loop"]        = @benchmarkable evaluate_colwise($dist, $a, $b)
            SUITE["colwise"][Tdist]["specialized"] = @benchmarkable colwise($dist, $a, $b)
        end
    end
end

add_colwise_benchmarks!(SUITE)


############
# Pairwise #
############

SUITE["pairwise"] = BenchmarkGroup()

function evaluate_pairwise(dist, x, y)
    nx = size(x, 2)
    ny = size(y, 2)
    T = typeof(evaluate(dist, x[:, 1], y[:, 1]))
    r = Matrix{T}(undef, nx, ny)
    for j = 1:ny
        @inbounds for i = 1:nx
            r[i, j] = @views evaluate(dist, x[:, i], y[:, j])
        end
    end
    return r
end

function add_pairwise_benchmarks!(SUITE)
    m = 100
    nx = 200
    ny = 250

    x = rand(m, nx)
    y = rand(m, ny)

    p = x
    for i = 1:nx
        p[:, i] /= sum(x[:, i])
    end

    q = y
    for i = 1:ny
        q[:, i] /= sum(y[:, i])
    end

    w = rand(m)
    Q = rand(m, m)
    Q = Q' * Q

    _dists, divs = create_distances(w, Q)

     for (dists, (a, b)) in [(_dists, (x,y)), (divs, (p,q))]
        for dist in (dists)
            Tdist = typeof(dist)
            SUITE["pairwise"][Tdist] = BenchmarkGroup()
            SUITE["pairwise"][Tdist]["loop"]        = @benchmarkable evaluate_pairwise($dist, $a, $b)
            SUITE["pairwise"][Tdist]["specialized"] = @benchmarkable pairwise($dist, $a, $b; dims=2)
        end
    end
end

add_pairwise_benchmarks!(SUITE)

Base.@deprecate pairwise!(r::AbstractMatrix, dist::PreMetric, a) pairwise!(dist, r, a)
Base.@deprecate pairwise!(r::AbstractMatrix, dist::PreMetric, a, b) pairwise!(dist, r, a, b)

Base.@deprecate pairwise!(
    r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix;
    dims::Union{Nothing,Integer}=nothing
) pairwise!(dist, r, a; dims=dims)
Base.@deprecate pairwise!(
    r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix, b::AbstractMatrix;
    dims::Union{Nothing,Integer}=nothing
) pairwise!(dist, r, a, b; dims=dims)

Base.@deprecate colwise!(r::AbstractArray, dist::PreMetric, a, b) colwise!(dist, r, a, b)

# docstrings for deprecated methods
@doc """
    pairwise!(r::AbstractMatrix, dist::PreMetric, a)

Same as `pairwise!(dist, r, a)`.

!!! warning
    Since this alternative syntax is deprecated and will be removed in a future release of
    Distances.jl, its use is discouraged. Please call `pairwise!(dist, r, a)` instead.
""" pairwise!(r::AbstractMatrix, dist::PreMetric, a)
@doc """
    pairwise!(r::AbstractMatrix, dist::PreMetric, a, b)

Same as `pairwise!(dist, r, a, b)`.

!!! warning
    Since this alternative syntax is deprecated and will be removed in a future release of
    Distances.jl, its use is discouraged. Please call `pairwise!(dist, r, a, b)` instead.
""" pairwise!(r::AbstractMatrix, dist::PreMetric, a, b)

@doc """
    pairwise!(r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix; dims)

Same as `pairwise!(dist, r, a; dims)`.

    !!! warning
    Since this alternative syntax is deprecated and will be removed in a future release of
    Distances.jl, its use is discouraged. Please call `pairwise!(dist, r, a; dims)` instead.
""" pairwise!(
    r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix;
    dims::Union{Nothing,Integer}
)
@doc """
    pairwise!(r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix, b::AbstractMatrix; dims)

Same as `pairwise!(dist, r, a, b; dims)`.

!!! warning
    Since this alternative syntax is deprecated and will be removed in a future release of
    Distances.jl, its use is discouraged. Please call `pairwise!(dist, r, a, b; dims)`
    instead.
""" pairwise!(
    r::AbstractMatrix, dist::PreMetric, a::AbstractMatrix, b::AbstractMatrix;
    dims::Union{Nothing,Integer}
)

@doc """
    colwise!(r::AbstractArray, dist::PreMetric, a, b)

Same as `colwise!(dist, r, a, b)`.

!!! warning
    Since this alternative syntax is deprecated and will be removed in a future release of
    Distances.jl, its use is discouraged. Please call `colwise!(dist, r, a, b)` instead.
""" colwise!(r::AbstractArray, dist::PreMetric, a, b)

using Distances

using Test
using LinearAlgebra
using OffsetArrays
using Random
using Statistics
using Unitful.DefaultSymbols

@test isempty(detect_ambiguities(Distances))

include("F64.jl")
include("test_dists.jl")

# Test ChainRules definitions on Julia versions that support weak dependencies
# Support for extensions was added in
# https://github.com/JuliaLang/julia/commit/93587d7c1015efcd4c5184e9c42684382f1f9ab2
# https://github.com/JuliaLang/julia/pull/47695 
if VERSION >= v"1.9.0-alpha1.18"
    include("chainrules.jl")
end

# dummy type wrapping a Float64 used in tests
struct F64 <: AbstractFloat
    x::Float64
end
F64(x::F64) = x

# operations
for op in (:+, :-, :sin, :cos, :asin, :acos)
    @eval Base.$op(a::F64) = F64($op(a.x))
end
for op in (:+, :-, :*, :/, :rem, isdefined(Base, :atan2) ? :atan2 : :atan)
    @eval Base.$op(a::F64, b::F64) = F64($op(a.x, b.x))
end
for op in (:zero, :one,)
    @eval Base.$op(::Type{F64}) = F64($op(Float64))
end

if VERSION >= v"0.7-"
    Random.rand(rng::AbstractRNG, ::Random.SamplerTrivial{Random.CloseOpen01{F64}}) = F64(rand(rng))
else
    Base.rand(rng::AbstractRNG, ::Type{F64}) = F64(rand())
end
Base.sqrt(a::F64) = F64(sqrt(a.x))
Base.:^(a::F64, b::Number) = F64(a.x^b)
Base.:^(a::F64, b::Int) = F64(a.x^b)
Base.:^(a::F64, b::F64) = F64(a.x^b.x)
Base.:^(a::Number, b::F64) = a^b.x
Base.log(a::F64) = F64(log(a.x))
Base.isfinite(a::F64) = isfinite(a.x)
Base.float(a::F64) = a.x
Base.rtoldefault(a::Type{F64}, b::Type{F64}) = Base.rtoldefault(Float64, Float64)
Base.mod(a::F64, b::F64) = mod(a.x, b.x)
# comparison
Base.isapprox(a::F64, b::F64) = isapprox(a.x, b.x)
Base.:<(a::F64, b::F64) = a.x < b.x
Base.:<=(a::F64, b::F64) = a.x <= b.x
Base.eps(::Type{F64}) = eps(Float64)

# promotion
Base.promote_rule(::Type{Float32}, ::Type{F64}) = Float64 # for eig
Base.promote_rule(::Type{Float64}, ::Type{F64}) = Float64 # for vecnorm
Base.promote(a::F64, b::T) where {T <: Number} = a, F64(float(b))
Base.promote(a::T, b::F64) where {T <: Number} = F64(float(a)), b

Base.convert(::Type{F64}, a::F64) = a
Base.convert(::Type{Float64}, a::F64) = a.x
Base.convert(::Type{F64}, a::T) where {T <: Number} = F64(a)

# conversion
Base.Float64(a::F64) = Float64(a.x)
Base.Int64(a::F64) = Int64(a.x)
Base.Int32(a::F64) = Int32(a.x)
